#ifndef NEXUSSERVER_H
#define NEXUSSERVER_H

#include <QObject>
#include <QSqlDatabase>
#include <QTcpServer>
#include <QList>

#include "client.h"
#include "console.h"

class NexusServer : public QObject
{
    Q_OBJECT
public:
    explicit NexusServer(QObject *parent = 0);
    ~NexusServer();
    void broadcastGlobal(QString);

signals:
    void clientConnected(Client*);
    void clientDisconnected(Client*);

public slots:
    void newConnection();

private:
    QSqlDatabase db;
    QTcpServer socket;
    QList<Client*> clients;
    Console con;
};

#endif // NEXUSSERVER_H
