#ifndef OPCODE_H
#define OPCODE_H

namespace Opcode {
    enum Code {
        // Before Login
        UserAuth = 4,
        SSOAuth = 204,
        UnknownAuth1 = 203,
        UnknownAuth2 = 197,
        UnknownAuth3 = 146,
        UnknownAuth4 = 46,
        CheckName = 42,
        RequestDate = 49,
        Register = 43,
        Prelogin1 = 202,
        Prelogin2 = 206,

        // After Login
        EnterRoom = 21,
        RequestAd = 182,
        RequestCharacter = 7,
        Unknown1 = 126,
        Unknown2 = 15,
        RoomInfo = 2,
        UserList = 61,
        FurnitureInfo = 62,
        Decorations = 66,
        BuyItem = 100,
        Heightmap = 60,
        PickupItem = 67,
        CreateRoom = 29,
        ListUserRooms = 16,
        PlaceFurniture = 90,
        RequestRoomList = 150,
        MiscRoomData = 64,
        Ping = 228,
        Ecotron = 223,
        Badges = 157,
        HabboClub = 26,
        Credits = 8,
        SearchUsers = 41,
        RequestFriend = 39,
        updateProfile = 44,
        moveFurniture = 73,
        updateRoomSettings1 = 24,
        updateRoomSettings2 = 25

    };
}

#endif // OPCODE_H
