#include <QSqlQuery>
#include <QVariant>

#include <stdio.h>

#include "utils.h"
#include "furnitureprofile.h"
#include "configengine.h"

void Utils::verifyDatabase(){
    QSqlQuery query;
    printf("                        [OK]\nVerifying database integrity... ");
    // with INTEGER PRIMARY KEY that column will autoincrement starting from 1, so you don't need to specify it when doing a INSERT INTO
    //ahh cool
    // also the (#) after varchar specifies the maximum length, varchar can only support 1-255
    // use TEXT or BLOB for anything bigger
    // TEXT is dynamically sized but can be slower
    // since if everything is specified it can just make pages and scan through them
    // where as if you use dynamic datatypes it has to scan the rows different to compensate
    // I love how SQL code looks lol
    // can  I ask one more kestion?
    query.prepare("CREATE TABLE IF NOT EXISTS accounts (id INTEGER PRIMARY KEY, username VARCHAR(50), password VARCHAR(32), figure VARCHAR(200), sex VARCHAR(1), email VARCHAR(64), bdate VARCHAR(64), motto VARCHAR(200))");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS friends (id INTEGER PRIMARY KEY, idone INTEGER, idtwo INTEGER, accepted INTEGER)"); // don't need accepted to be an integer, but like lots of other db types in here, I don't know my MySQL :P
    query.exec();
    //query.prepare("DROP TABLE IF EXISTS privatecats");
    //query.exec();
    query.prepare("CREATE TABLE IF NOT EXISTS privatecats (id INTEGER PRIMARY KEY, title VARCHAR(150))");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS posters (id INTEGER PRIMARY KEY, sprite VARCHAR(64), x INTEGER, y INTEGER, rot INTEGER, cust VARCHAR(64), inhand INTEGER, inroom INTEGER)");
    query.exec();
    //query.prepare("DROP TABLE IF EXISTS rooms");
    //query.exec();
    //query.prepare("DROP TABLE IF EXISTS heightmaps");
    //query.exec();
    query.prepare("CREATE TABLE IF NOT EXISTS rooms (id INTEGER PRIMARY KEY, title VARCHAR(250), desc VARCHAR(250), owner INTEGER, ownerstr VARCHAR(50), usercount INTEGER, maxcount INTEGER, category INTEGER, model VARCHAR(64), showowner INTEGER)");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS heightmaps (id INTEGER PRIMARY KEY, model VARCHAR(64), map BLOB, doorx INTEGER, doory INTEGER, doorh VARCHAR(24))");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS paints (id INTEGER PRIMARY KEY, inroom INTEGER, color INTEGER, placement VARCHAR(32))");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS consolemissions (id INTEGER PRIMARY KEY, mission VARCHAR(128), username VARCHAR(64))");
    query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS ssotickets (accountid INTEGER PRIMARY KEY, ticket VARCHAR(128))");
    query.exec();

    //query.prepare("DROP TABLE IF EXISTS furniture");
    //query.exec();

    query.prepare("CREATE TABLE IF NOT EXISTS furniture (id INTEGER PRIMARY KEY, inroom INTEGER, inhand INTEGER, sprite VARCHAR(64), x INTEGER, y INTEGER, length INTEGER, width INTEGER, rot INTEGER, z INTEGER, color VARCHAR(250), status VARCHAR(250), teleid INTEGER, stackh VARCHAR(32))");
    query.exec();

//    query.prepare("INSERT INTO rooms (id, title, desc, owner, ownerstr, usercount, maxcount, category, model, showowner) VALUES(:id, :title, :desc, :owner, :ownerstr, :usercount, :maxcount, :cat, :model, :show)");
//    query.bindValue(":id", "420", QSql::In);
//    query.bindValue(":title", "NexusServer test room", QSql::In);
//    query.bindValue(":desc", "OMG ROOM DESCRIPTION WORKS.", QSql::In);
//    query.bindValue(":owner", "334", QSql::In);
//    query.bindValue(":ownerstr", "Nexus", QSql::In);
//    query.bindValue(":usercount", "0", QSql::In);
//    query.bindValue(":maxcount", "25", QSql::In);
//    query.bindValue(":cat", "51", QSql::In);
//    query.bindValue(":model", "model_a", QSql::In);
//    query.bindValue(":show", "1", QSql::In);
//    query.exec();
//    query.prepare("INSERT INTO rooms (id, title, desc, owner, ownerstr, usercount, maxcount, category, model, showowner) VALUES(:id, :title, :desc, :owner, :ownerstr, :usercount, :maxcount, :cat, :model, :show)");
//    query.bindValue(":id", "421", QSql::In);
//    query.bindValue(":title", "NexusServer test room 2", QSql::In);
//    query.bindValue(":desc", "OMG ROOM DESCRIPTION WORKS.", QSql::In);
//    query.bindValue(":owner", "334", QSql::In);
//    query.bindValue(":ownerstr", "Nexus", QSql::In);
//    query.bindValue(":usercount", "0", QSql::In);
//    query.bindValue(":maxcount", "25", QSql::In);
//    query.bindValue(":cat", "51", QSql::In);
//    query.bindValue(":model", "model_a", QSql::In);
//    query.bindValue(":show", "1", QSql::In);
//    query.exec();

    bool dodb = ConfigEngine::getValue("VerifyDatabase").operator == ("true");


    if(dodb){

        query.prepare("INSERT INTO privatecats (id, title) VALUES(:id, :title)");
        query.bindValue(":id", "51", QSql::In);
        query.bindValue(":title", "General", QSql::In);
        query.exec();
        query.prepare("INSERT INTO privatecats (id, title) VALUES(:id, :title)");
        query.bindValue(":id", "50", QSql::In);
        query.bindValue(":title", "Trading", QSql::In);
        query.exec();
        query.prepare("INSERT INTO privatecats (id, title) VALUES(:id, :title)");
        query.bindValue(":id", "72", QSql::In);
        query.bindValue(":title", "Scripting", QSql::In);
        query.exec();
        query.prepare("INSERT INTO privatecats (id, title) VALUES(:id, :title)");
        query.bindValue(":id", "70", QSql::In);
        query.bindValue(":title", "Admin Only", QSql::In);
        query.exec();


    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "1", QSql::In);
    //    query.bindValue(":model", "model_a", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxx00000000\nxxxxxxxxxxxx\nxxxxxxxxxxxx\n", QSql::In);
    //    query.exec();

        /* below generated automatically */
        //query.prepare("DROP TABLE IF EXISTS heightmaps");


    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "2", QSql::In);
    //    query.bindValue(":model", "model_a", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "3", QSql::In);
    //    query.bindValue(":model", "model_b", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "4", QSql::In);
    //    query.bindValue(":model", "model_c", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "5", QSql::In);
    //    query.bindValue(":model", "model_d", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "6", QSql::In);
    //    query.bindValue(":model", "model_e", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "7", QSql::In);
    //    query.bindValue(":model", "model_f", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxxxx0000x\rxxxxxxx0000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rx0000000000x\rx0000000000x\rx0000000000x\rx0000000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "8", QSql::In);
    //    query.bindValue(":model", "model_g", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "9", QSql::In);
    //    query.bindValue(":model", "model_h", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx000000x\rxxxxx000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "10", QSql::In);
    //    query.bindValue(":model", "model_i", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxx\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "11", QSql::In);
    //    query.bindValue(":model", "model_j", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "12", QSql::In);
    //    query.bindValue(":model", "model_k", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx\r\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "13", QSql::In);
    //    query.bindValue(":model", "model_l", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rxxxxxxxxxxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "14", QSql::In);
    //    query.bindValue(":model", "model_m", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "15", QSql::In);
    //    query.bindValue(":model", "model_n", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx000000xxxxxxxx000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000xxxxxxxx000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rxxxxxxxxxxxxxxxxxxxxx\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "16", QSql::In);
    //    query.bindValue(":model", "model_o", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx00000000xxxx\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "17", QSql::In);
    //    query.bindValue(":model", "model_p", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxx\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx22222222xxxx\rxxxxxxx11111111xxxx\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx2222xx11111111xxxx\rx2222xx00000000xxxx\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rxxxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "18", QSql::In);
    //    query.bindValue(":model", "model_q", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx2222xxxxxxxxxxxxxx\rx2222xxxxxxxxxxxxxx\rx2222211111xx000000\rx222221111110000000\rx222221111110000000\rx2222211111xx000000\rxx22xxx1111xxxxxxxx\rxx11xxx1111xxxxxxxx\rx1111xx1111xx000000\rx1111xx111110000000\rx1111xx111110000000\rx1111xx1111xx000000\rxxxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO heightmaps (id, model, map) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "19", QSql::In);
    //    query.bindValue(":model", "model_r", QSql::In);
    //    query.bindValue(":map", "xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rx4444433333xxxxxxxxxxxxxx\rx4444433333xxxxxxxxxxxxxx\rx44444333333222xx000000xx\rx44444333333222xx000000xx\rxxx44xxxxxxxx22xx000000xx\rxxx33xxxxxxxx11xx000000xx\rxxx33322222211110000000xx\rxxx33322222211110000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxxxxxxxxxx", QSql::In);
    //    query.exec();



        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"2\", \"model_a\", \"xxxxxxxxxxxx\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r\", \"3\", \"5\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"3\", \"model_b\", \"xxxxxxxxxxxx\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r\", \"0\", \"5\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"4\", \"model_c\", \"xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\", \"4\", \"7\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"5\", \"model_d\", \"xxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\r\", \"4\", \"7\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"6\", \"model_e\", \"xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r\", \"1\", \"5\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"7\", \"model_f\", \"xxxxxxxxxxxx\rxxxxxxx0000x\rxxxxxxx0000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rx0000000000x\rx0000000000x\rx0000000000x\rx0000000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r\", \"2\", \"5\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"8\", \"model_g\", \"xxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\", \"1\", \"7\", \"1.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"9\", \"model_h\", \"xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx000000x\rxxxxx000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\", \"4\", \"4\", \"1.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"10\", \"model_i\", \"xxxxxxxxxxxxxxxxx\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rxxxxxxxxxxxxxxxxx\", \"0\", \"10\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"11\", \"model_j\", \"xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxx\r\", \"0\", \"10\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"12\", \"model_k\", \"xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx\r\r\", \"0\", \"13\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"13\", \"model_l\", \"xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rxxxxxxxxxxxxxxxxxxxxx\r\", \"0\", \"16\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"14\", \"model_m\", \"xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\", \"0\", \"15\", \"1.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"15\", \"model_n\", \"xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx000000xxxxxxxx000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000xxxxxxxx000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rxxxxxxxxxxxxxxxxxxxxx\r\", \"0\", \"16\", \"0.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"16\", \"model_o\", \"xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx00000000xxxx\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx\", \"0\", \"18\", \"1.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"17\", \"model_p\", \"xxxxxxxxxxxxxxxxxxx\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx22222222xxxx\rxxxxxxx11111111xxxx\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx2222xx11111111xxxx\rx2222xx00000000xxxx\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rxxxxxxxxxxxxxxxxxxx\", \"0\", \"23\", \"2.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"18\", \"model_q\", \"xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx2222xxxxxxxxxxxxxx\rx2222xxxxxxxxxxxxxx\rx2222211111xx000000\rx222221111110000000\rx222221111110000000\rx2222211111xx000000\rxx22xxx1111xxxxxxxx\rxx11xxx1111xxxxxxxx\rx1111xx1111xx000000\rx1111xx111110000000\rx1111xx111110000000\rx1111xx1111xx000000\rxxxxxxxxxxxxxxxxxxx\", \"10\", \"4\", \"2.0\");"); query.exec();
        query.prepare("INSERT INTO heightmaps (id, model, map, doorx, doory, doorh) VALUES(\"19\", \"model_r\", \"xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rx4444433333xxxxxxxxxxxxxx\rx4444433333xxxxxxxxxxxxxx\rx44444333333222xx000000xx\rx44444333333222xx000000xx\rxxx44xxxxxxxx22xx000000xx\rxxx33xxxxxxxx11xx000000xx\rxxx33322222211110000000xx\rxxx33322222211110000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxxxxxxxxxx\", \"10\", \"4\", \"3.0\");"); query.exec();



        //query.prepare("DROP TABLE IF EXISTS catalog");
        //query.exec();

        query.prepare("CREATE TABLE IF NOT EXISTS catalog (id INTEGER PRIMARY KEY, pagename VARCHAR(128), pagepacket BLOB)");
        query.exec();
        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "2", QSql::In);
        query.bindValue(":model", "Accessories", QSql::In);
        query.bindValue(":map", "i:Accessories\rn:Accessories\rl:ctlg_layout2\rs:2: I love my rabbit...\rh:Is your room missing something?  Well, now you can add the finishing touches that express your true personality. And don't forget, like everything else, these accessories can be moved about to suit your mood.\rg:catalog_extra_headline1\rw:Click on the item you want for more information.\re:catalog_extra_teaser1,\rp:Digital TV\tBang up to date\t6\t\ts\ttv_luxus\t0\t1,3\tA2 DIGITV\t\rp:Large TV\tFor family viewing\t4\t\ts\twood_tv\t0\t1,2\tA2 WTV\t\rp:Portable TV\tDon?t miss those soaps\t3\t\ts\tred_tv\t0\t1,1\tA2 RTV\t\rp:Pad of stickies\tPad of stickies\t3\t\ti\tpost.it 20\t\t\tA2 tlp 20\t\rp:Pizza Box\tYou dirty Habbo\t3\t\ts\tpizza\t0\t1,1\tA1 PIZ\t\rp:Empty Cans\tAre you a slob too?\t3\t\ts\tdrinks\t0\t1,1\tA1 DRK\t\rp:Empty Spinning Bottle\tFor interesting games!\t3\t!\ts\tbottle\t0\t1,1\tA2 PUL\t\rp:Holo-dice\tWhat's your lucky number?\t6\t\ts\tedice\t0\t1,1\tA2 NOPPA\t0,0,0\rp:Cake\tSave me a slice!\t4\t\ts\thabbocake\t0\t1,1\ta2 habbocake\t0,0,0\rp:Menorah\tLight up your room\t3\t\ts\tmenorah\t0\t1,1\ta2 menorah\t0,0,0\rp:Squidgy Bunny\tYours to cuddle up to\t3\t\ts\tbunny\t0\t1,1\ta2 bunny\t0,0,0\rp:Mummy\tBeware the curse...\t3\t\ti\tposter 44\t\t\tposter 44\t\rp:White Candle Plate\tSimple but stylish\t3\t\ts\twcandleset\t0\t1,1\ta2 wcandles\t0,0,0\rp:Red Candles on a Plate\tSimple but stylish\t3\t\ts\trcandleset\t0\t1,1\ta2 rcandles\t0,0,0\rp:Joint of Ham\tTuck in\t3\t\ts\tham\t0\t1,1\tA2 ham\t0,0,0\rp:Lert\tSet it off.\t5\t\ts\thockey_light\t0\t1,1\ta0 goallight\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "3", QSql::In);
        query.bindValue(":model", "Aquamarine Iced", QSql::In);
        query.bindValue(":map", "i:Aquamarine Iced\rn:Aquamarine Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_aqua\t0,#9ABFBD,#9ABFBD,#9ABFBD\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_aqua\t0,0,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_aqua\t0,#9ABFBD\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_aqua\t#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_aqua\t0,#9ABFBD,#9ABFBD\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_aqua\t#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_aqua\t0,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_aqua\t0,#9ABFBD,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_aqua\t0,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_aqua\t0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_aqua\t0,0,#9ABFBD,#9ABFBD", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "4", QSql::In);
        query.bindValue(":model", "Area", QSql::In);
        query.bindValue(":map", "i:Area\rn:Area\rl:ctlg_layout2\rs:2: Beautiful in it's simplicity!\rw:Click on the item you want for more information.\rg:catalog_area_headline1\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. It's beautiful in its simplicity, and welcoming to everyone.\re:catalog_area_teaser1,\rp:Double Bed\tPlain and simple x2\t3\t\ts\tbed_silo_two\t0\t2,3\tA1 S2S\t0,0,0\rp:Single Bed\tPlain and simple\t3\t\ts\tbed_silo_one\t0\t1,3\tA1 S1S\t0,0,0\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_silo\t0\t2,1\tA1 KHS\t0,0,0\rp:Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 SHS\t0,0,0,0,#A2C6C8,#A2C6C8\rp:Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 STS\t0,0,#A2C6C8,#A2C6C8,0\rp:Occasional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 PPS\t0,#A2C6C8,0,#A2C6C8\rp:Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 silovi\t0,0,0,#A2C6C8\rp:Screen\tStylish sectioning\t3\t\ts\tdivider_silo2\t0\t2,1\ta1 sildiv\t0,0,0\rp:Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 silkp\t0,#A2C6C8,0,#A2C6C8\rp:Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 TUS\t0,0,#A2C6C8,#A2C6C8,0\rp:Safe Minibar\tTotally shatter-proof!\t3\t\ts\tsafe_silo\t0\t1,1\t3 safe_silo\t0,#A2C6C8,0\rp:Bar Stool\tPractical and convenient\t3\t\ts\tbarchair_silo\t0\t1,1\t3 barchair_silo\t0,#A2C6C8,0\rp:Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 PYS\t0,#8FAEAF\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "5", QSql::In);
        query.bindValue(":model", "Asian", QSql::In);
        query.bindValue(":map", "i:Asian\rn:Asian\rl:ctlg_layout2\rs:2\rh:Introducing the Unqiue Chinese/Asian section. Here you can buy some great Asian Furni for your Habbo Room!\rg:catalog_asian_headline1\rw:\re:catalog_asian_teaser1,\rp:Calligraphy poster\tchinese calligraphy\t3\t\ti\tposter 57\t\t\tposter 57\rp:Red Knot Thing\tWall hangings oriental style\t5\t\ti\tposter 58\t\t\tposter 58\rp:Red Knot\tWall hangings oriental style\t10\t\ts\tcn_sofa\t2\t3,1\t10 cn_sofa\t0,0,0\rp:lantern\toriental light\t15\t\ts\tcn_lamp\t2\t1,1\t15 cn_lamp\t0,0,0\rp:Chinese Lacquer Table\tExotic and classy\t10\t\ts\tchina_table\t2\t1,1\t10 china_table\t0,0,0\rp:Chinese Bookshelf\tTo hold the mind's treasures\t10\t\ts\tchina_shelve\t2\t2,1\t10 china_shelve\t0,0,0\rp:Chinese Laquer Chair\tThe elegant beauty of tradition\t10\t\ts\tchair_china\t2\t1,1\t10 china_chair\t0,0,0\rp:Dragon Screen\tFor your great wall\t10\t\ts\twall_china\t2\t1,1\t10 wall_china\t0,0,0\rp:Dragon Screen Corner\tFirm, fireproof foundation\t10\t\ts\tcorner_china\t2\t1,1\t10 corner_china\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "6", QSql::In);
        query.bindValue(":model", "Bank", QSql::In);
        query.bindValue(":map", "i:Bank\rn:Bank\rl:ctlg_layout2\rg:catalog_bank_teaser\rw:Click on an item to see more details\rs:Not well? Money! Get some gold bars now!\rh:If you have any of the gold bars in your room you can exchange for Habbo Credits. How? Go to your Room, Place them on the floor, Dubble click and voila. <br>PLEASE NOTE: This only work in your room! \re:catalog_bank_teaser,\rp:Bronze Coin\tWorth: 1 Habbo Credit\t1\t\ts\tCF_1_coin_bronze\t0\t1,1\tA0 CF_1_coin_bronze\t0,0,0\rp:Silver Coin\tWorth: 5 Habbo Credits\t5\t\ts\tCF_5_coin_silver\t0\t1,1\tA0 CF_5_coin_silver\t0,0,0\rp:Gold Coin\tWorth: 10 Habbo Credits\t10\t\ts\tCF_10_coin_gold\t0\t1,1\tA0 CF_10_coin_gold\t0,0,0\rp:Money Bag\tWorth: 20 Habbo Credits\t20\t\ts\tCF_20_moneybag\t0\t1,1\tA0 CF_20_moneybag\t0,0,0\rp:Gold Bars\tWorth: 50 Habbo Credits\t50\t\ts\tCF_50_goldbar\t0\t1,1\tA0 CF_50_goldbar\t0,0,0\rp:Gold Money Bag\tWorth: 100 Habbo Credits\t100\t\ts\tCFC_100_moneybag_gold\t0\t1,1\tA0 CFC_100_moneybag_gold\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "7", QSql::In);
        query.bindValue(":model", "Bank of Habbo", QSql::In);
        query.bindValue(":map", "i:Rares:Mode\rl:ctlg_layout\rs:1:                    Rares!\rw:Klik op de item voor meet informatie.\rg:catalog_rares_headline1\rh:Bank Of Habbo made by sami/s-yoyolover.\re:catalog_presents_teaser2,\rp:Onbekend\tOnbekend\t25\t\ts\tCFC_10_coin_bronze\t0\t1,1\t25 CFC_10_coin_bronze\t0,0,0\rp:Onbekend\tOnbekend\t25\t\ts\tCFC_50_coin_silver\t0\t1,1\t25 CFC_50_coin_silver\t0,0,0\rp:Onbekend\tOnbekend\t25\t\ts\tCFC_100_coin_gold\t0\t1,1\t25 CFC_100_coin_gold\t0,0,0\rp:Onbekend\tOnbekend\t6\t\ts\tCFC_200_moneybag\t0\t1,1\t25 CFC_200_moneybag\t0,0,0\rp:Onbekend\tOnbekend\t2\t\ts\tCFC_500_goldbar\t0\t1,1\t2 CFC_500_goldbar\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "8", QSql::In);
        query.bindValue(":model", "Bathroom", QSql::In);
        query.bindValue(":map", "i:Bathroom\rn:Bathroom\rl:ctlg_layout2\rs:2:  Every Habbo needs one!\rw:Click on the item you want for more information.\rg:catalog_bath_headline1\rh:Introducing the Bathroom Collection...  Have some fun with the cheerful bathroom collection. Give yourself and your guests somewhere to freshen up - vital if you want to avoid nasty niffs. Put your loo in a corner though...\re:catalog_bath_teaser1,\rp:Bubble Bath\tThe ultimate in pampering\t6\t\ts\tbath\t0\t1,2\tA2 AMME\t\rp:Sink\tHot and cold thrown in for no charge\t3\t\ts\tsink\t0\t1,1\tA1 LAVUAARI\t\rp:Rubber Duck\tEvery bather needs one\t1\t\ts\tduck\t0\t1,1\tA1 KUMIANKKA\t\rp:Loo Seat\tLoo Seat\t4\t\ts\ttoilet\t0\t1,1\tA2 PYTTYSIN\t\rp:Loo Seat\tLoo Seat\t4\t\ts\ttoilet_red\t0\t1,1\tA2 PYTTYPUN\t\rp:Loo Seat\tLoo Seat\t4\t\ts\ttoilet_yell\t0\t1,1\tA2 PYTTYKELT\t\rp:Floor Tiles\tIn a choice of colours\t3\t\ts\ttile\t0\t4,4\tA2 KAAKELISIN\t\rp:Floor Tiles\tIn a choice of colours\t3\t\ts\ttile_red\t0\t4,4\tA2 KAAKELIPUN\t\rp:Floor Tiles\tIn a choice of colours\t3\t\ts\ttile_yell\t0\t4,4\tA2 KAAKELIKELT\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "9", QSql::In);
        query.bindValue(":model", "Beige Mode", QSql::In);
        query.bindValue(":map", "i:Beige Mode\rn:Beige Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed_beige\t0,0,#D0C6A5,#D0C6A5,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed_beige\t0,0,0,#D0C6A5,#D0C6A5,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa_beige\t0,0,0,0,#D0C6A5,#D0C6A5\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair_beige\t0,0,#D0C6A5,#D0C6A5,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate_beige\t0,0,0,#D0C6A5,#D0C6A5\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar_beige\t0,0,#D0C6A5,#D0C6A5\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar_beige\t0,#D0C6A5,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "10", QSql::In);
        query.bindValue(":model", "Black Iced", QSql::In);
        query.bindValue(":map", "i:Black Iced\rn:Black Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_black\t0,#4C4C4C,#4C4C4C,#4C4C4C\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_black\t0,0,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_black\t0,#4C4C4C\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_black\t#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_black\t0,#4C4C4C,#4C4C4C\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_black\t#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_black\t0,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_black\t0,#4C4C4C,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_black\t0,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_black\t0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_black\t0,0,#4C4C4C,#4C4C4C", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "11", QSql::In);
        query.bindValue(":model", "Black Mode", QSql::In);
        query.bindValue(":map", "i:Black Mode\rn:Black Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed_black\t0,0,#686868,#686868,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed_black\t0,0,0,#686868,#686868,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa_black\t0,0,0,0,#686868,#686868\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair_black\t0,0,#686868,#686868,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate_black\t0,0,0,#686868,#686868\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar_black\t0,0,#686868,#686868\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar_black\t0,#686868,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "12", QSql::In);
        query.bindValue(":model", "Blue Iced", QSql::In);
        query.bindValue(":map", "i:Blue Iced\rn:Blue Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_blue\t0,#9FC2C4,#9FC2C4,#9FC2C4\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_blue\t0,0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_blue\t0,#9FC2C4\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_blue\t#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_blue\t0,#9FC2C4,#9FC2C4\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_blue\t#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_blue\t0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_blue\t0,#9FC2C4,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_blue\t0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_blue\t0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_blue\t0,0,#9FC2C4,#9FC2C4", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "13", QSql::In);
        query.bindValue(":model", "Blue Mode", QSql::In);
        query.bindValue(":map", "i:Blue Mode\rn:Blue Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Blue Mode Collection...  Get the greatest looking Mode for just as much as the Original! This is a great Time to buy if your feeling Blue.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed_blue\t0,0,#519AD1,#519AD1,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed_blue\t0,0,0,#519AD1,#519AD1,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa_blue\t0,0,0,0,#519AD1,#519AD1\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair_blue\t0,0,#519AD1,#519AD1,0\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate_blue\t0,0,0,#519AD1,#519AD1\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar_blue\t0,0,#519AD1,#519AD1\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar_blue\t0,#519AD1,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "14", QSql::In);
        query.bindValue(":model", "Camera", QSql::In);
        query.bindValue(":map", "i:Camera\rn:Camera\rl:ctlg_camera1\rs:\ru:Camera2\rt1:When you've used your free photos, you'll need to buy more? Each Film (5 photos) costs 6 Credits. <br><br>Your Camera will show how much film you have left and loads the next roll automatically.\rw:\rg:catalog_camera_headline1\rh:Take a picture and keep a record of those special moments forever.  With your Habbo camera you can take pictures of just about anything in the Hotel ? Even your friend on the loo...<br><br>A Camera costs 10 Credits (TWO FREE photos  included).\re:campic_cam,campic_film,\rp:Camera\tSmile!\t10\t\ts\tcamera\t0\t1,1 10 kamera\t0,0,0\rp:Film\tFilm for five photos\t6\t\td\t\t\t\t6 film", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "15", QSql::In);
        query.bindValue(":model", "Camera2", QSql::In);
        query.bindValue(":map", "i:Camera2\rn:Camera2\rl:ctlg_camera2\ru:Camera\rh:CAMERA FUNCTIONS - See Above<br><br>1. Click this button to take a photo.<br>2. Click to cancels the photo you took.<br>3. Click to zoom in and out.<br>4. This shows how many photos are left.<br>5. Caption Box ? Write a message and save it.<br>6. Save ? Keep your photo forever.<br><br>You can trade photos to your friends, or put them on the wall like posters.\rg:catalog_camera_headline1\re:campic_help,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "16", QSql::In);
        query.bindValue(":model", "Candy", QSql::In);
        query.bindValue(":map", "i:Candy\rn:Candy\rl:ctlg_layout2\rs:2: Get off my chair fool!\rh:Candy Furni.\rg:catalog_candy_headline1\rw:Click an item for more details.\re:catalog_candy_teaser1,\rp:Pink Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon*5\t0\t2,1\tA5 cbar\t#ffffff,#ffffff,#FF9BBD,#FF9BBD\rp:Pink Corner\tTuck it away\t3\t\ts\tbardeskcorner_polyfon*5\t0\t1,1\tA5 ccbar\t#ffffff,#FF9BBD\rp:Pink Gate (lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3*5\t0\t1,1\tA5 cgate\t#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Armchair\tThink pink\t3\t\ts\tsofachair_polyfon_girl\t0\t1,1\tA1 GIRLSTP\t#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Two-seater Sofa\tRomantic pink for two\t4\t\ts\tsofa_polyfon_girl\t0\t2,1\tA2 GIRLSHP\t#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4\rp:Pink Faux-Fur Bear Rug\tCute\t4\t\ts\tcarpet_polar*1\t0\t2,3\tA2 MURLOVE\t#ffbbcf,#ffbbcf,#ffddef\rp:Armchair\tThink pink\t3\t\ts\tbed_polyfon_girl_one\t0\t1,3\tA1 GIRLS1P\t#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Double Bed\tSnuggle down in princess pink\t4\t\ts\tbed_polyfon_girl\t0\t2,3\tA2 GIRLS2P\t#ffffff,#ffffff,#EE7EA4,#EE7EA4", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "18", QSql::In);
        query.bindValue(":model", "Christmas", QSql::In);
        query.bindValue(":map", "i:Christmas\rn:Christmas\rl:ctlg_layout2\rg:catalog_xmas_headline1\rw:Click on an item to see a bigger version of it!\rh:The Habbo Christmas catalogue has everything you need to make the perfect festive room: Trees, ducks with santa hats on, puddings and of course, Menorahs!\rs:2:Tuck into Christmas!\re:catalog_xmas_teaser,\rp:Christmas Tree 1\tAny presents under it yet?\t6\t\ts\ttree3\t0\t1,1\t10 xmas1\t0,0,0\rp:Christmas Tree 2\tAny presents under it yet?\t6\t\ts\ttree4\t0\t1,1\t10 xmas2\t0,0,0\rp:Christmas Tree 3\tAny presents under it yet?\t6\t\ts\ttree5\t0\t1,1\t10 xmas3\t0,0,0\rp:Electric Candles\tNo need to worry about wax drips\t3\t\ts\ttriplecandle\t0\t1,1\t10 electriccandles\t0,0,0\rp:Roast Turkey\tWhere's the cranberry sauce?\t3\t\ts\tturkey\t0\t1,1\t10 turkeys\t0,0,0\rp:Holly Garland\tDeck the halls!\t3\t\ti\tposter 27\t\t\tposter 27\rp:Gingerbread House \tGood enough to eat\t3\t\ts\thouse\t0\t1,1\t10 gbread1\t0,0,0\rp:Reindeer Poster\tDoing a hard night's work\t3\t\ti\tposter 25\t\t\tposter 25\rp:Three Wise Men Poster\tFollowing the star!\t3\t\ti\tposter 24\t\t\tposter 24\rp:Santa Poster Poster\tThe jolly fat man himself\t3\t\ti\tposter 23\t\t\tposter 23\rp:Stocking\tHung yours up yet?\t3\t\ti\tposter 26\t\t\tposter 26\rp:Christmas Pudding \tWill you get the lucky sixpence?\t3\t\ts\tpudding\t0\t1,1\t10 pudding\t0,0,0\rp:Mistletoe\tPucker up\t3\t\ti\tposter 30\t\t\tposter 30\rp:Christmas Rubber Duck \tA right Christmas quacker!\t2\t\ts\txmasduck\t0\t1,1\t10 xmasduck\t0,0,0\rp:Pink Hyacinth \tBeautiful bulb\t3\t\ts\thyacinth1\t0\t1,1\t10 hyacinth1\t0,0,0\rp:Blue Hyacinth \tBeautiful bulb\t3\t\ts\thyacinth2\t0\t1,1\t10 hyacinth2\t0,0,0\rp:Poinsetta \tChristmas in a pot\t3\t\ts\tjoulutahti\t0\t1,1\t10 joulutahti\t0,0,0\rp:Red Candle \tXmas tea light\t3\t\ts\trcandle\t0\t1,1\t10 rcandle\t0,0,0\rp:White Candle \tXmas tea light\t3\t\ts\twcandle\t0\t1,1\t10 wcandle\t0,0,0\rp:Winter Wonderland Poster\tA chilly snowy scene\t3\t\ti\tposter 22\t\t\tposter 22\rp:Snowman Poster\tA new use for carrots!\t3\t\ti\tposter 20\t\t\tposter 20\rp:Large gold star\tAll that glitters...\t3\t\ti\tposter 48\t\t\tposter 48\rp:Large silver star\tAll that glitters...\t3\t\ti\tposter 49\t\t\tposter 49\rp:Tinsel (gold)\tA touch of festive sparkle\t3\t\ti\tposter 29\t\t\tposter 29\rp:Tinsel (silver)\tA touch of festive sparkle\t3\t\ti\tposter 28\t\t\tposter 28\rp:Small gold star\tTwinkle, twinkle\t3\t\ti\tposter 46\t\t\tposter 46\rp:Small silver star\tTwinkle, twinkle\t3\t\ti\tposter 47\t\t\tposter 47\rp:Angel Poster\tSee that halo gleam!\t3\t\ti\tposter 21\t\t\tposter 21\r", QSql::In);
        query.exec();

    //    query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "19", QSql::In);
    //    query.bindValue(":model", "Club Furni", QSql::In);
    //    query.bindValue(":map", "i:Club Furni\rn:Club Furni\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_club_headline1\rh:Welcome to the club furni page. Here you can buy any club furni for just 25 credits!\rw:\re:catalog_presents_teaser2,\rp:Club sofa\tClub sofa\t25\t\ts\tclub_sofa\t0\t2,1\t3 club_sofa\t0,0,0\rp:HC chair\tAqua chair\t3\t\ts\tchair_plasto*14\t0\t1,1\tA1 aqua_chair\t#ffffff,#3CB4F0,#ffffff,#3CB4F0\rp:HC table\tAqua table\t3\t\ts\ttable_plasto_4leg*14\t0\t2,2\tA1 aqua_table\t#ffffff,#3CB4F0,#ffffff,#3CB4F0\rp:Mochamaster\tWake up and smell it!\t25\t\ts\tmocchamaster\t0\t1,1\t3 mocchamaster\t0,0,0\rp:Dicemaster\tClick and roll!\t25\t\ts\tedicehc\t0\t1,1\t3 edicehc\t0,0,0\rp:Tubmaster\tTime for a soak\t25\t\ts\thcamme\t0\t1,2\t3 hcamme\t0,0,0\rp:Imperial Teleport\tLet's go over tzar!\t25\t\ts\tdoorD\t0\t1,1\t3 ovi4\t0,0,0\rp:Throne Sofa\tFor royal bottoms...\t25\t\ts\thcsohva\t0\t2,1\t3 hcsohva\t0,0,0\rp:Oil Lamp\tBe enlightened\t25\t\ts\thc_lmp\t0\t1,1\t3 hc_lmp\t0,0,0\rp:Nordic Table\tPerfect for banquets\t25\t\ts\thc_tbl\t0\t1,3\t3 hc_tbl\t0,0,0\rp:Majestic Chair\tRoyal comfort\t25\t\ts\thc_chr\t0\t1,1\t3 hc_chr\t0,0,0\rp:Study Desk\tFor Habbo scholars\t25\t\ts\thc_dsk\t0\t1,2\t3 hc_dsk\t0,0,0\r", QSql::In);
    //    query.exec();

    //    query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
    //    query.bindValue(":id", "20", QSql::In);
    //    query.bindValue(":model", "Club Furni 2", QSql::In);
    //    query.bindValue(":map", "i:Club Furni 2\rn:Club Furni 2\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_club_headline1\rh:Welcome to the club furni page. Here you can buy any club furni for just a small ammount of credits!\rw:\re:catalog_presents_teaser2,\rp:Habbo Club Trolly\tThe life of luxery\t25\t\ts\thc_trll\t0\t1,2\t25 hctrolly\t0,0,0\rp:Habbo Club Lamp\tLight up the Room\t25\t\ts\thc_lmpst\t0\t1,1\t25 hclamp\t0,0,0\rp:Habbo Club Curtain\tVelvet Certain\t25\t\ts\thc_crtn\t0\t2,1\t25 hcertain\t0,0,0\rp:Habbo Club Television\tWidescreen with High Definition\t50\t\ts\thc_tv\t0\t2,1\t3 hctv\t0,0,0\rp:Habbo Club Butler\tAt your Service\t25\t\ts\thc_btlr\t0\t1,1\t25 hcbutler\t0,0,0\rp:Habbo Club Bookshelf\tLuxery at a Price\t50\t\ts\thc_bkshlf\t0\t1,4\t50 hcbook\t0,0,0\rp:Habbo Club Xray Machine\tRadaition Alert\t25\t\ts\thc_rntgn\t0\t2,1\t25 hcscan\t0,0,0\r\r\rp:Habbo Club Control Panel\tPress some switches\t25\t\ts\thc_machine\t0\t1,3\t25 hcmachine\t0,0,0\r\rp:Habbo Club Fireplace\tWarmth and Light\t25\t\ts\thc_frplc\t0\t1,3\t25 hcfire\t0,0,0\rp:HabboClub DJ Set\tBeats up ze music\t25\t\ts\thc_djset\t0\t3,1\t25 hcmusic\t0,0,0", QSql::In);
    //    query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "21", QSql::In);
        query.bindValue(":model", "Club Shop", QSql::In);
        query.bindValue(":map", "i:Club Shop\rn:Club Shop\rl:ctlg_layout2\rs:\rh:Habbo Club Rares.\rg:catalog_rares_headline1\rw:Click on an item for more details.\re:catalog_presents_teaser2,\rp:Drinks Trolley\tFor swanky dinners only\t25\t\ts\thc_trll\t0\t1,2\t25 hctrolly\t0,0,0\rp:Victorian Street Light\tSomber and atmospheric\t25\t\ts\thc_lmpst\t0\t1,1\t25 hclamp\t0,0,0\rp:Antique Drapery\tTopnotich privacy protection\t25\t\ts\thc_crtn\t0\t2,1\t25 hcertain\t0,0,0\rp:Mega TV Set\tForget plasma, go HC!\t25\t\ts\thc_tv\t0\t2,1\t25 hctv\t0,0,0\rp:Electric Butler\tYour personal caretaker\t25\t\ts\thc_btlr\t0\t1,1\t25 hcbutler\t0,0,0\rp:Medieval Bookcase\tFor the scholarly ones\t25\t\ts\thc_bkshlf\t0\t1,4\t25 hcbook\t0,0,0\rp:X-Ray Divider\tBelieve it or not!\t25\t\ts\thc_rntgn\t0\t2,1\t25 hcscan\t0,0,0\rp:Weird Science Machine\tBy and for mad inventors\t25\t\ts\thc_machine\t0\t1,3\t25 hcmachine\t0,0,0\rp:Heavy Duty Fireplace\tPixel=powered for maximum heating\t25\t\ts\thc_frplc\t0\t1,3\t25 hcfire\t0,0,0\rp:The Grammophon\tVery old skool scrathc'n'spin\t25\t\ts\thc_djset\t0\t3,1\t25 hcmusic\t0,0,0\rp:Persian Carpet\tUltimate craftsmanship\t10\t\ts\thc_crpt\t0\t3,5\t10 hc_crpt\t0,0,0\rp:HC Roller\tHighest class transportation\t7\t\ts\thc_rllr\t0\t1,1\t7 hc_rllr\t0,0,0\rp:Club Sofa\tHC Sofa\t10\t\ts\tclub_sofa\t0\t1,1\t10 club_sofa\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "22", QSql::In);
        query.bindValue(":model", "Easter", QSql::In);
        query.bindValue(":map", "i:Easter\rn:Easter\rl:ctlg_layout2\rs:2: I love my bunny!\rw:Click on an item to see a bigger version of it!\rg:catalog_easter_headline1\rh:It's easter! Time for some easter furni. Here is the collection of this year...\re:catalog_easter_teaser1,\r\rp:Wannabe bunny\tCan you tell what it is yet?\t2\t\ts\teasterduck\t0\t1,1\t2 easterduck\t0,0,0\r\r\rp:Pop-up Egg\tCheep (!) and cheerful\t5\t\ts\tbirdie\t0\t1,1\t5 birdie\t0,0,0\r\r\rp:Basket Of Eggs\tEggs-actly what you want for Easter\t4\t\ts\tbasket\t0\t1,1\t4 basket\t0,0,0\r\r\rp:Squidgy Bunny\tYours to cuddle up to\t3\t\ts\tbunny\t0\t1,1\t3 bunny\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "23", QSql::In);
        query.bindValue(":model", "Fans", QSql::In);
        query.bindValue(":map", "i:Fans\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the fans page. Here you can buy any colour fan that blows you away!\rw:\re:catalog_presents_teaser2,\rp:Purple Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 purple_fan\t#C05DFF,0,0,0\rp:Brown Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 brown_fan\t#97420C,0,0,0\rp:Ochre Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 ochre_fan\t#FF8000,0,0,0\rp:Fucsia Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 fucsia_fan\t#FF60B0,0,0,0\rp:Yellow Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 yellow_fan\t#E1CC00,0,0,0\rp:Blue Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 blue_fan\t#3C75FF,0,0,0\rp:Turquoise  Powered Fan\tIt'll blow you away!\t25\t\ts\trare_fan*2\t1\t1,1\t3 turquoise_fan\t#00E5E2,0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "24", QSql::In);
        query.bindValue(":model", "Flags", QSql::In);
        query.bindValue(":map", "i:Flags\rn:Flags\rl:ctlg_layout2\rs:2:  Flag this section for later!\rw:Click on the item you want for more information.\rg:catalog_flags_headline1\rh:If you're feeling patriotic, get a flag to prove it. Our finest cloth flags will brighten up the dullest walls.\re:catalog_flags_teaser1,\rp:Union Jack\tThe UK flag\t5\t\ti\tposter 500\t\t\tposter 500\t\rp:The Swedish flag\tWaved by Swedes everywhere\t3\t\ti\tposter 515\t\t\tposter 515\rp:The Australian flag\tAussies rule!\t3\t\ti\tposter 513\t\t\tposter 513\t\rp:The EU flag\tBe proud to be in the Union!\t3\t\ti\tposter 514\t\t\tposter 514\t\rp:The Irish flag\tThe flag of Ireland\t3\t\ti\tposter 512\t\t\tposter 512\t\rp:The Dutch flag\tThe flag of The Netherlands\t3\t\ti\tposter 511\t\t\tposter 511\t\rp:The Italian flag\tThe flag of Italy\t3\t\ti\tposter 510\t\t\tposter 510\t\rp:The Jamaican flag\tThe flag of Jamaica\t3\t\ti\tposter 509\t\t\tposter 509\t\rp:The Spanish flag\tThe flag of Spain\t3\t\ti\tposter 508\t\t\tposter 508\t\rp:The Bundesflagge\tThe German flag\t3\t\ti\tposter 504\t\t\tposter 504\t\rp:The flag of Finland\tTo 'Finnish' your decor...\t3\t\ti\tposter 506\t\t\tposter 506\t\rp:The French Tricolore\tThe French flag\t3\t\ti\tposter 507\t\t\tposter 507\t\rp:The Maple Leaf\tThe Canadian flag\t3\t\ti\tposter 505\t\t\tposter 505\t\rp:The English flag\tEng-er-land\t3\t\ti\tposter 516\t\t\tposter 516\t\rp:The Rainbow Flag\tEvery colour for everyone\t3\t\ti\tposter 520\t\t\tposter 520\t\rp:The Scottish flag\tWhere's your kilt?\t3\t\ti\tposter 517\t\t\tposter 517\t\rp:The Welsh flag\tA fiery dragon for your wall\t3\t\ti\tposter 518\t\t\tposter 518\t\rp:The Stars and Stripes\tThe US flag\t3\t\ti\tposter 502\t\t\tposter 502\t\rp:The Swiss flag\tThere's no holes in this...\t3\t\ti\tposter 503\t\t\tposter 503\t\rp:Flag of Brazil\tThe flag of Brazil\t3\t\ti\tposter 521\t\t\tposter 521\t\rp:Jolly Roger\tFor pirates everywhere\t3\t\ti\tposter 501\t\t\tposter 501\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "1", QSql::In);
        query.bindValue(":model", "Frontpage", QSql::In);
        query.bindValue(":map", "i:Frontpage\rn:Frontpage\rl:ctlg_frontpage2\rs:Need some Funky Furni for your Habbo room?\rt1:You need Habbo Credits to buy Furni for your room, but your credits will never decrease, so buy as much as you like!\rw:Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?\rg:catal_fp_header\rh:Need some Furni for your Habbo room?  Well, you're in the right place!  This Catalogue is packed FULL of funky Furni, just click the tabs on the right to browse.<br><br>We regularly add and remove Furni, so check back regularly for new items.<br><br>\re:catal_fp_pic4,catal_fp_pic5,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "26", QSql::In);
        query.bindValue(":model", "Gallery", QSql::In);
        query.bindValue(":map", "i:Gallery\rn:Gallery\rl:ctlg_layout2\rs:2: Brighten up your walls!\rh:Adorn your walls with wondrous works of art, posters, plaques and wall hangings. We have items to suit all tastes, from kitsch to cool, traditional to modern.\rg:catalog_gallery_headline1\rw:Click on the item you want for more information.\re:catalog_posters_teaser1,\rp:Rug on the wall\tRug\t10\t\ti\tposter 2001\t\t\tposter 2001\rp:DJ Carlos\tDJ Carlos\t3\t\ti\tposter 2003\t\t\tposter 2003\t\rp:Rastaman\tRasta tarjoaa rakkautta\t3\t\ti\tposter 2004\t\t\tposter 2004\t\rp:Suom kartta\tSuom kartta\t3\t\ti\tposter 2000\t\t\tposter 2000\t\rp:Presidentin Muotokuva\tPresidentin Muotokuva\t10\t\ti\tposter 2002\t\t\tposter 2002\t\rp:Johnny Squabble\tSportly\t10\t\ti\tposter 1005\t\t\tposter 1005\t\rp:Hammer Cabinet\tfor emergencies only\t3\t\ti\tposter 7\t\t\tposter 7\t\rp:Skyline Poster\tskyscrapers at night\t3\t\ti\tposter 12\t\t\tposter 12\t\rp:BW Skyline Poster\tskyscrapers in arty black and white\t3\t\ti\tposter 13\t\t\tposter 13\t\rp:Fox Poster\ta truly cunning design\t3\t\ti\tposter 14\t\t\tposter 14\t\rp:Three Wise Men Poster\tFollowing the star!\t3\t\ti\tposter 24\t\t\tposter 24\t\rp:Butterfly Cabinet\tbeautiful reproduction butterfly\t3\t\ti\tposter 17\t\t\tposter 17\t\rp:Butterfly Cabinet (blue)\tbeautiful reproduction butterfly\t3\t\ti\tposter 18\t\t\tposter 18\t\rp:Bars\thigh security for your room\t3\t\ti\tposter 16\t\t\tposter 16\t\rp:UK Map\tget the lovely isles on your walls\t3\t\ti\tposter 1003\t\t\tposter 1003\t\rp:Himalaya Poster\tmarvellous mountains\t3\t\ti\tposter 15\t\t\tposter 15\t\rp:Hoot Poster\tThe eyes follow you...\t3\t\ti\tposter 1006\t\t\tposter 1006\t\rp:Siva Poster\tThe Auspicious One\t3\t\ti\tposter 32\t\t\tposter 32\t\rp:Save the Panda\tWe can't bear to lose them\t3\t\ti\tposter 33\t\t\tposter 33\t\rp:Carrot Plaque\ttake pride in your veg!\t3\t\ti\tposter 2\t\t\tposter 2\t\rp:Fish Plaque\tsmells fishy, looks cool\t3\t\ti\tposter 3\t\t\tposter 3\t\rp:Bear Plaque\tfake of course!\t3\t\ti\tposter 4\t\t\tposter 4\t\rp:Duck Poster\tquacking good design!\t3\t\ti\tposter 5\t\t\tposter 5\t\rp:Ancestor Poster\ta touch of history\t3\t\ti\tposter 1\t\t\tposter 1\t\rp:Abstract Poster\tbut is it the right way up?\t3\t\ti\tposter 6\t\t\tposter 6\t\rp:Queen Mum Poster\taw, bless...\t3\t\ti\tposter 1002\t\t\tposter 1002\t\rp:Prince Charles Poster\tEven walls have ears\t3\t\ti\tposter 1001\t\t\tposter 1001\t\rp:Habbo Colours Poster\tHabbos come in all colours\t3\t\ti\tposter 8\t\t\tposter 8\t\rp:Rainforest Poster\tdo your bit for the environment\t3\t\ti\tposter 9\t\t\tposter 9\rp:Eid Mubarak\tCelebrate with us\t3\t\ti\tposter 1004\t\t\tposter 1004\t\rp:DJ Throne\tHe is the magic Habbo\t3\t\ti\tposter 2006\t\t\tposter 2006\t\rp:The Father of Habbo\tThe Founder\t3\t\ti\tposter 2007\t\t\tposter 2007\rp:Green Gecko Art\tLike a gecko it wont fall of your wall\t3\t\ti\tposter 2008\t\t\tposter 2008\t\rp:Certificate\taward, charter or the Habbo Way - you decide\t3\t\ti\tposter 11\t\t\tposter 11\t\rp:Habbo Golden Record\tFor the best music-makers\t3\t\ti\tposter 41\t\t\tposter 41\t\rp:Bonnie Blonde\tThe one and only. Adore her!\t3\t\ti\tposter 40\t\t\tposter 40\t\rp:The Habbo Babes 1\tThe Hotel's girlband. Dream on!\t3\t\ti\tposter 35\t\t\tposter 35\t\rp:The Habbo Babes 2\tThe Hotel's girlband. Dream on!\t3\t\ti\tposter 36\t\t\tposter 36\t\rp:The Habbo Babes 3\tThe Hotel's girlband. Dream on!\t3\t\ti\tposter 37\t\t\tposter 37\t\rp:Johnny Squabble\tThe muscly movie hero\t3\t\ti\tposter 1005\t\t\tposter 1005\t\rp:Scamme'd\tHabbo-punk for the never-agreeing\t3\t\ti\tposter 34\t\t\tposter 34\t\rp:Screaming Furnies\tThe rock masters of virtual music\t3\t\ti\tposter 39\t\t\tposter 39\t\rp:Scamme'd\tHabbo-punk for the never-agreeing\t3\t\ti\tposter 34\t\t\tposter 34\t\rp:Presidentin muotokuva\tUrho Kaleva Kekkonen\t3\t\ti\tposter 2002\t\t\tposter 2002\t\rp:Suomen kartta\tSuomen kartta\t3\t\ti\tposter 2000\t\t\tposter 2000\t\rp:Smiling Headbangerz\tFor really TOUGH Habbos!\t3\t\ti\tposter 38\t\t\tposter 38\t\rp:Habbo Cola Poster\tFor serious bubblers\t3\t\ti\tposter 2008\t\t\tposter 2008\t\rp:The Father Of Habbo\tThe legendary founder of the Hotel\t3\t\ti\tposter 2007\t\t\tposter 2007\t\rp:Dodgy Geezer\tWould you trust this man?\t3\t\ti\tposter 2003\t\t\tposter 2003\t\rp:Save the Panda\tWe can't bear to lose them\t3\t\ti\tposter 33\t\t\tposter 33\t\rp:System of a Ban\tPure and unbridled nu-metal\t3\t\ti\tposter 31\t\t\tposter 31\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "27", QSql::In);
        query.bindValue(":model", "Glass", QSql::In);
        query.bindValue(":map", "i:Glass\rn:Glass\rl:ctlg_layout2\rt1:\rg:catalog_glass_headline1\rh:\rw:\re:catalog_presents_teaser2,\rp:Glass Chair\tTranslucent beauty\t3\t\ts\tglass_chair\t1\t1,1\t3 glass_chair\t0,#C3C3C3,#C3C3C3\rp:Glass Sofa\tTranslucent beauty\t3\t\ts\tglass_sofa\t1\t2,1\t3 glass_sofa\t0,#C3C3C3,#C3C3C3\rp:Glass Shelf\tTranslucent beauty\t3\t\ts\tglass_shelf\t1\t2,1\t3 glass_shelf\t0,0,0\rp:Glass Stool\tTranslucent beauty\t3\t\ts\tglass_stool\t1\t1,1\t3 glass_stool\t0,#C3C3C3,#C3C3C3\rp:Glass Table\tTranslucent beauty\t3\t\ts\tglass_table\t1\t2,2\t3 glass_table\t0,#C3C3C3,#C3C3C3\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "28", QSql::In);
        query.bindValue(":model", "Gothic", QSql::In);
        query.bindValue(":map", "i:Gothic\rn:Gothic\rl:ctlg_layout2\rg:catalog_gothic_headline1\rw:Click on the item you want for more information.s:\rh:Here you can buy the red gothic Furni line. \re:catalog_gothic_teaser1,\rp:Rode Goth troon\tDuister smeedwerk\t10\t\ts\tgothic_chair*3\t0\t1,1\ta3 gothicchair\t#ffffff,#dd0000,#ffffff,#dd0000\rp:Rode Goth bank\tDuister smeedwerk\t7\t\ts\tgothic_sofa*3\t0\t2,1\ta3 gothicsofa\t#ffffff,#dd0000,#ffffff,#ffffff,#dd0000,#ffffff\rp:Rode Goth stoel\tDuister smeedwerk\t5\t\ts\tgothic_stool*3\t0\t1,1\ta3 gothicstool\t#ffffff,#dd0000,#ffffff\rp:Carpet1\tRug\t5\t\ts\tgothic_carpet\t0\t2,4\ta3 gothic_carpet1\t0,0,0\rp:Carpet2\tRug\t5\t\ts\tgothic_carpet2\t0\t2,4\ta3 gothic_carpet2\t0,0,0\rp:Goth tafel\tDuister smeedwerk\t15\t\ts\tgoth_table\t0\t1,5\ta0 goth_table\t0,0,0\rp:Goth hekwerk\tDuister smeedwerk\t8\t\ts\tgothrailing\t0\t2,1\ta0 gothrailing\t0,0,0\rp:Goth fakkel\tVuur in het duister\t10\t\ti\ttorch\t\t\ta0 torch\t\rp:Goth fountain\tBlub blub..\t10\t\ti\tgothicfountain\t\t\ta0 gothicfountain\t\rp:Goth kandelaar\tDuister smeedwerk\t10\t\ts\tgothiccandelabra\t0\t1,1\ta0 gothiccandelabra\t0,0,0\rp:Goth poort\tDuister smeedwerk\t10\t\ts\tgothgate\t0\t2,1\ta0 gothgate\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "29", QSql::In);
        query.bindValue(":model", "Green Iced", QSql::In);
        query.bindValue(":map", "i:Green Iced\rn:Green Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_green\t0,#73A531,#73A531,#73A531\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_green\t0,0,0,#73A531,#73A531,#73A531,#73A531,#73A531\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_green\t0,#73A531\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_green\t#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531,#73A531\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_green\t0,#73A531,#73A531\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_green\t#73A531,#73A531,#73A531,#73A531,#73A531,#73A531\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_green\t0,0,#73A531,#73A531,#73A531,#73A531\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_green\t0,#73A531,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_green\t0,0,#73A531,#73A531,#73A531,#73A531\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_green\t0,#73A531,#73A531,#73A531,#73A531\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_green\t0,0,#73A531,#73A531", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "30", QSql::In);
        query.bindValue(":model", "Green Mode", QSql::In);
        query.bindValue(":map", "i:Green Mode\rn:Green Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed_green\t0,0,#759C34,#759C34,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed_green\t0,0,0,#759C34,#759C34,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa_green\t0,0,0,0,#759C34,#759C34\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair_green\t0,0,#759C34,#759C34,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate_green\t0,0,0,#759C34,#759C34\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar_green\t0,0,#759C34,#759C34\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar_green\t0,#759C34,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "31", QSql::In);
        query.bindValue(":model", "Habbo Club", QSql::In);
        query.bindValue(":map", "i:Habbo Club\rn:Habbo Club\rl:ctlg_club1\rt2:Habbo Club is Habbo Hotel's exclusive club.  As a member of this club you get privileges that are not available to none Habbo Club Habbos. Habbo Club will cost you 25 credits a month, but it is well worth the money, as a member you get; priority access to the Hotel, exclusive clothes, hair colours, Furni, special guest room layouts AND a BADGE!\ru:Habbo Club2\rt3:To join Habbo Club use the Navigator to go to 'Hotel View', then click on the Habbo Club icon. A pop-up will open and you can, just follow the instructions.\rg:catalog_club_headline1\rt1:Welcome to Habbo Club, the exclusive members-only club that gives YOU so much more!\rt4:The EXCLUSIVE members-only club, Join TODAY!\re:clubcat_pic,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "32", QSql::In);
        query.bindValue(":model", "Habbo Club 2", QSql::In);
        query.bindValue(":map", "i:Habbo Club 2\rn:Habbo Club 2\rl:ctlg_layout2\rs:\rh:Here you can buy the new Habbo Club rares.\rg:catalog_club_headline1\rw:Click on the item you want for more information.\re:catalog_presents_teaser2,\rp:Habbo Club Trolly\tThe life of luxery\t25\t\ts\thc_trll\t0\t1,2\t25 hctrolly\t0,0,0\r\rp:Habbo Club Carpet\tIt's not flying!\t25\t\ts\thc_crpt\t0\t3,5\t25 hc_crpt\t0,0,0\rp:Habbo Club Lamp\tLight up the Room\t25\t\ts\thc_lmpst\t0\t1,1\t25 hclamp\t0,0,0\rp:Habbo Club Curtain\tVelvet Certain\t25\t\ts\thc_crtn\t0\t2,1\t25 hcertain\t0,0,0\rp:Habbo Club Television\tWidescreen with High Definition\t50\t\ts\thc_tv\t0\t2,1\t3 hctv\t0,0,0\rp:Habbo Club Butler\tAt your Service\t25\t\ts\thc_btlr\t0\t1,1\t25 hcbutler\t0,0,0\rp:Habbo Club Bookshelf\tLuxery at a Price\t50\t\ts\thc_bkshlf\t0\t1,4\t50 hcbook\t0,0,0\rp:Habbo Club Xray Machine\tRadaition Alert\t25\t\ts\thc_rntgn\t0\t2,1\t25 hcscan\t0,0,0\r\r\rp:Habbo Club Control Panel\tPress some switches\t25\t\ts\thc_machine\t0\t1,3\t25 hcmachine\t0,0,0\r\rp:Habbo Club Fireplace\tWarmth and Light\t25\t\ts\thc_frplc\t0\t1,3\t25 hcfire\t0,0,0\rp:HabboClub DJ Set\tBeats up ze music\t25\t\ts\thc_djset\t0\t3,1\t25 hcmusic\t0,0,0\rp:HC Rollers\tFirst Place Transport!\t25\t\td\t\t\t\tdeal0111\t\t1\thc_rllr\t5\t0,0,0\rp:Hc Lamp\tGimme the light!\t25\t\ti\thc_wall_lamp\t\t\ta0 hc_wall_lamp", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "33", QSql::In);
        query.bindValue(":model", "Habbo Club New", QSql::In);
        query.bindValue(":map", "i:bankofhabbo\rn:bankofhabbo\rl:ctlg_layout2\rs:2: Passen?          Ze zijn in de Catalogus! Jeuh!\rw:Klik op een meubel voor meer informatie!\rg:catalog_bankofhabbo_headline1\rh:Introducing the Pura Collection...  This collection breathes fresh, clean air and cool tranquillity. Use it to create a special haven away from the hullabaloo of life outside the Hotel.\re:catalog_bankofhabbo_teaser1,\r\rp:null\tnull\t25\t\ts\thc_lmpst\t0\t1,1\t25 hc_lmpst\t0,0,0\r\r\rp:null\tnull\t25\t\ts\thc_crtn\t0\t2,1\t25 hc_crtn\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_trll\t0\t1,2\t25 hc_trll\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_rllr\t0\t1,1\t25 hc_rllr\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_tv\t0\t2,1\t25 hc_tv\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_btlr\t0\t1,1\t25 hc_btlr\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_frplc\t0\t1,3\t25 hc_frplc\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_bkshlf\t0\t1,4\t25 hc_bkshlf\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_machine\t0\t1,3\t25 hc_machine\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_crpt\t0\t3,5\t25 hc_crpt\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_rntgn\t0\t2,1\t25 hc_rntgn\t0,0,0\r\rp:null\tnull\t25\t\ts\thc_djset\t0\t3,1\t25 hc_djset\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "34", QSql::In);
        query.bindValue(":model", "Habbo Club2", QSql::In);
        query.bindValue(":map", "i:Habbo Club2\rn:Habbo Club2\rl:ctlg_club2\rt2:If your Habbo Club runs out, you WILL be able to keep any rooms you have made with a Habbo Club layout and the Habbo Club Furni is yours to keep.\ru:Club\rt3:If your Habbo Club runs out you WON'T be able to wander round with a cool HC badge, the funky clothes and hair will vanish from your Habbo ID, you won't be able to choose HC room layouts in the Room-O-Matics, you'll receive no new HC Furni and worst all, you won't be able to jump the queue if the Hotel's Full!\rg:catalog_club_headline1\rt1:What happens when my Habbo Club runs out?\rt4:Stay in Habbo Club for more than a year and you'll get a special sparkly BADGE!\re:club_pos,club_neg,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "35", QSql::In);
        query.bindValue(":model", "Habbo Exchange", QSql::In);
        query.bindValue(":map", "i:Habbo Exchange\rn:Habbo Exchange\rl:ctlg_layout2\rg:catalog_bank_headline1\rw:Click on the item you want for more information.\rs:Refundable goods!\rh:The Habbo Exchange is where you can convert your Habbo Credits into a tradable currency. You can use this tradable currency to exchange Habbo Credits for Furni! \re:catalog_bank_teaser,\rp:Golden coin\tWorth 10 Credits\t10\t\ts\tCF_10_coin_gold\t0\t1,1\tA0 CF_10_coin_gold\t0,0,0\rp:Silver Coin\tWorth 5 Credits\t5\t\ts\tCF_5_coin_silver\t0\t1,1\tA0 CF_5_coin_silver\t0,0,0\rp:Bronze Coin\tWorth 1 Credit\t1\t\ts\tCF_1_coin_bronze\t0\t1,1\tA0 CF_1_coin_bronze\t0,0,0\rp:Sack of Credits\tWorth 20 Credits\t20\t\ts\tCF_20_moneybag\t0\t1,1\tA0 CF_20_moneybag\t0,0,0\rp:Gold Bar\tWorth 50 Credits\t50\t\ts\tCF_50_goldbar\t0\t1,1\tA0 CF_50_goldbar\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "36", QSql::In);
        query.bindValue(":model", "Halloween", QSql::In);
        query.bindValue(":map", "i:Halloween\rn:Halloween\rl:ctlg_layout2\rg:catalog_halloween_headline1\rw:Click on an item to see a bigger version of it!\rh:Yes, it's a spookfest! Get your boney hands on our creepy collection of ghoulish goodies. But be quick - they'll be gone from the Catalogue after two weeks!\rs:2:Halloween is MY day!\re:catalog_halloween_teaser,\rp:Pumpkin Lamp\tCast a spooky glow\t6\t\ts\tpumpkin\t0\t1,1\t6 pumpkin\t0,0,0\rp:Spiderweb\tNot something you want to run into\t3\t\ti\tposter 42\t\t\tposter 42\rp:Chains\tShake, rattle and roll!\t4\t\ti\tposter 43\t\t\tposter 43\rp:Skull Candle Holder\tAlas poor Yorrick...\t4\t\ts\tskullcandle\t0\t1,1\t4 skullcandle\t0,0,0\rp:Skeleton\tNeeds a few more Habburgers\t3\t\ti\tposter 45\t\t\tposter 45\rp:Mummy\tBeware the curse...\t3\t\ti\tposter 44\t\t\tposter 44\rp:Dead Duck\tBlood, but no guts 8\t2\t\ts\tdeadduck\t0\t1,1\t2 deadduck\t0,0,0\rp:Dead Duck 2\tSomeone forgot to feed me...\t2\t\ts\tdeadduck2\t0\t1,1\t2 deadduck2\t0,0,0\rp:Dead Duck 3\tWith added ectoplasm\t2\t\ts\tdeadduck3\t0\t1,1\t2 deadduck3\t0,0,0\rp:Bat Poster\tflap, flap, screech, screech...\t3\t\ti\tposter 50\t\t\tposter 50\rp:Jolly Roger\tFor pirates everywhere\t3\t\ti\tposter 501\t\t\tposter 501\rp:Eaten Ham\tLooks like you're too late!\t3\t\ts\tham2\t0\t1,1\t2 ham2\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "37", QSql::In);
        query.bindValue(":model", "HC2", QSql::In);
        query.bindValue(":map", "i:HC2\rn:HC2\rl:ctlg_layout2\rs:\rh:Here you can buy the new Habbo Club rares.\rg:catalog_club_headline1\rw:Click on the item you want for more information.\re:catalog_presents_teaser2,\rp:Habbo Club Trolly\tThe life of luxery\t25\t\ts\thc_trll\t0\t1,2\t25 hctrolly\t0,0,0\r\rp:Habbo Club Carpet\tIt's not flying!\t25\t\ts\thc_crpt\t0\t3,5\t25 hc_crpt\t0,0,0\rp:Habbo Club Lamp\tLight up the Room\t25\t\ts\thc_lmpst\t0\t1,1\t25 hclamp\t0,0,0\rp:Habbo Club Curtain\tVelvet Certain\t25\t\ts\thc_crtn\t0\t2,1\t25 hcertain\t0,0,0\rp:Habbo Club Television\tWidescreen with High Definition\t50\t\ts\thc_tv\t0\t2,1\t3 hctv\t0,0,0\rp:Habbo Club Butler\tAt your Service\t25\t\ts\thc_btlr\t0\t1,1\t25 hcbutler\t0,0,0\rp:Habbo Club Bookshelf\tLuxery at a Price\t50\t\ts\thc_bkshlf\t0\t1,4\t50 hcbook\t0,0,0\rp:Habbo Club Xray Machine\tRadaition Alert\t25\t\ts\thc_rntgn\t0\t2,1\t25 hcscan\t0,0,0\r\r\rp:Habbo Club Control Panel\tPress some switches\t25\t\ts\thc_machine\t0\t1,3\t25 hcmachine\t0,0,0\r\rp:Habbo Club Fireplace\tWarmth and Light\t25\t\ts\thc_frplc\t0\t1,3\t25 hcfire\t0,0,0\rp:HabboClub DJ Set\tBeats up ze music\t25\t\ts\thc_djset\t0\t3,1\t25 hcmusic\t0,0,0\rp:HC Rollers\tFirst Place Transport!\t25\t\td\t\t\t\tdeal0111\t\t1\thc_rllr\t5\t0,0,0\rp:Hc Lamp\tGimme the light!\t25\t\ti\thc_wall_lamp\t\t\ta0 hc_wall_lamp", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "38", QSql::In);
        query.bindValue(":model", "Ice Cream Machines", QSql::In);
        query.bindValue(":map", "i:Ice Cream Machines\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Ice Cream page, you can purchase any colour for only a few credits, but be quick because they won't be here long!\rw:\re:catalog_presents_teaser2,\rp:Red Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 red_ice\t#FFFFFF,#F43100,0,0,0\rp:Blue Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 blue_ice\t#FFFFFF,#3C75FF,0,0,0\rp:Choco Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 choco_ice\t#FFFFFF,#97420C,0,0,0\rp:Aqua Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 aqua_ice\t#FFFFFF,#00E5E2,0,0,0\rp:Green Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 green_ice\t#FFFFFF,#55CD01,0,0,0\rp:Ochre Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 ochre_ice\t#FFFFFF,#FF8000,0,0,0\rp:Fucsia Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 Fucsia_ice\t#FFFFFF,#FF60B0,0,0,0\rp:Pink Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*0\t1\t1,1\t3 pink_ice\t#FFFFFF,#FF9898,0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "39", QSql::In);
        query.bindValue(":model", "Iced", QSql::In);
        query.bindValue(":map", "i:Iced\rn:Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN\t0,#E2DAAC,#E2DAAC,#E2DAAC\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN\t0,0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN\t0,#E2DAAC\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN\t#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn\t0,#E2DAAC,#E2DAAC\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN\t#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv\t0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp\t0,#E2DAAC,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4\t0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5\t0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi\t0,0,#E2DAAC,#E2DAAC", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "40", QSql::In);
        query.bindValue(":model", "Iced Black", QSql::In);
        query.bindValue(":map", "i:Iced\rn:Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN\t0,0,0,0\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN\t0,0,0,0,0,0,0,0\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN\t0,0\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN\t0,0\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn\t0,0,0\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN\t0,0,0,0,0,0\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv\t0,0,0,0\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp\t0,0\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi\t0,0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "41", QSql::In);
        query.bindValue(":model", "Iced Blue", QSql::In);
        query.bindValue(":map", "i:Iced\rn:Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_blue\t0,#9FC2C4,#9FC2C4,#9FC2C4\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_blue\t0,0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_blue\t0,#9FC2C4\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_blue\t#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_blue\t0,#9FC2C4,#9FC2C4\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_blue\t#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_blue\t0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_blue\t0,#9FC2C4,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_blue\t0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_blue\t0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_blue\t0,0,#9FC2C4,#9FC2C4", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "42", QSql::In);
        query.bindValue(":model", "Laser Gates", QSql::In);
        query.bindValue(":map", "i:Laser Gates\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Laser page You can Purchase any colour Laser for just a few credits!\rw:\re:catalog_presents_teaser2,,\rp:Red Laser Door\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*0\t0\t1,1\t3 red_laser\t#ffffff,#dd2d22,#ffffff,#ffffff,#ffffff,#dd2d22\rp:Violet Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*9\t0\t1,1\t3 violet_laser\t#ffffff,#7733ff,#ffffff,#ffffff,#ffffff,#7733ff\rp:Purple Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*8\t0\t1,1\t3 purple_laser\t#ffffff,#bb55cc,#ffffff,#ffffff,#ffffff,#bb55cc\rp:Turquoise Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*7\t0\t1,1\t3 Turquoise_Laser\t#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc\rp:White Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*6\t0\t1,1\t3 white_laser\t#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Black Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*5\t0\t1,1\t3 black_laser\t#ffffff,#555555,#ffffff,#ffffff,#ffffff,#555555\rp:Pink Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*4\t0\t1,1\t3 pink_laser\t#ffffff,#ff5577,#ffffff,#ffffff,#ffffff,#ff5577\rp:Jade Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*3\t0\t1,1\t3 jade_laser\t#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70\rp:Blue Laser Portal\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*2\t0\t1,1\t3 blue_laser\t#ffffff,#5599ff,#ffffff,#ffffff,#ffffff,#5599ff\rp:Yellow Laser Door\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*1\t0\t1,1\t3 yellow_laser\t#ffffff,#ffbc00,#ffffff,#ffffff,#ffffff,#ffbc00\r\n", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "43", QSql::In);
        query.bindValue(":model", "Lodge", QSql::In);
        query.bindValue(":map", "i:Lodge\rn:Lodge\rl:ctlg_layout2\rs:2: I LOVE this wood Furni!\rw:Click on the item you want for more information.\rg:catalog_lodge_headline1\rh:Introducing the Lodge Collection...  Do you appreciate the beauty of wood?  For that ski lodge effect, or to match that open fire... Lodge is the Furni of choice for Habbos with that no frills approach to decorating.  <br>\re:catalog_lodge_teaser1,\rp:Double Bed\tKing-sized pine comfort\t3\t\ts\tbed_armas_two\t0\t2,3\tA2 S2A\t0,0,0\rp:Single Bed\tRustic charm for one\t3\t\ts\tbed_armas_one\t0\t1,3\tA1 S1A\t0,0,0\rp:Fireplace\tAuthentic, real flame fire\t4\t\ts\tfireplace_armas\t0\t2,1\tA2 TAA\t0,0,0\rp:Bardesk\tBar-Style Table - essential for extra guests\t3\t\ts\tbartable_armas\t0\t1,3\tA1 BTA\t\rp:Dining Table\tFor informal dining\t3\t\ts\ttable_armas\t0\t2,2\tA2 PIA\t0,0,0\rp:Bench\tTo complete the dining set\t3\t\ts\tbench_armas\t0\t2,1\tA1 PEA\t0,0,0\rp:Gate (lockable)\tKnock, knock...\t6\t\ts\tdivider_arm3\t0\t1,1\ta2 armovi\t0,0,0\rp:Corner plinth\tGood solid wood\t3\t\ts\tdivider_arm1\t0\t1,1\ta1 armkp\t0,0,0\rp:Room divider\tI wooden go there\t3\t\ts\tdivider_arm2\t0\t2,1\ta1 armdiv\t0,0,0\rp:Bookcase\tFor all those fire-side stories\t3\t\ts\tshelves_armas\t0\t2,1\tA1 KHA\t0,0,0\rp:Barrel Minibar\tIt's a barrel of laughs and a great talking point\t4\t\ts\tbar_armas\t0\t1,1\tA2 BAA\t\rp:Barrel Stool\tThe ultimate recycled furniture\t1\t\ts\tbar_chair_armas\t0\t1,1\tA1 BJA\t\rp:Table Lamp\tAmbient lighting is essential\t3\t\ts\tlamp_armas\t0\t1,1\tA1 JLA\t0,0,0\rp:Lodge candle\tWax lyrical with some old-world charm\t3\t\ts\tlamp2_armas\t0\t1,1\ta2 kya\t0,0,0\rp:Occasional Table\tPractical and beautiful\t2\t\ts\tsmall_table_armas\t0\t1,1\tA1 PPA\t0,0,0\rp:Stool\tRustic charm at it's best\t1\t\ts\tsmall_chair_armas\t0\t1,1\tA1 JAA\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "44", QSql::In);
        query.bindValue(":model", "Love", QSql::In);
        query.bindValue(":map", "i:Love\rn:Love\rl:ctlg_layout2\rg:catalog_love_headline1\rw:Click on an item to see a bigger version of it!\rh:The love collection has everything to create the perfect love room, for a good price!\rp:Heart Sofa\tPerfect for snuggling up on\t3\t\ts\theartsofa\t0\t2,1\t10 heartsofa\t0,0,0\rp:Cupid Statue\tWatch out for those arrows!\t3\t\ts\tstatue\t0\t1,1\t10 statue\t0,0,0\rp:Giant Heart\tFull of love\t6\t\ts\theart\t0\t2,1\t10 heart\t0,0,0\rp:Valentine's Duck\tHe's lovestruck\t2\t\ts\tvaleduck\t0\t1,1\t10 valeduck\t0,0,0\rp:Heart stickies\tHeart stickies\t3\t\ti\tpost.it.vd\t\t\tA2 tlp2 20\t\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "45", QSql::In);
        query.bindValue(":model", "Marquee", QSql::In);
        query.bindValue(":map", "i:Marquee\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Marquee page. Here you can buy any colour Marquee for just a few credits!\rw:\re:catalog_presents_teaser2,\rp:Blue Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 blue_marquee #ffffff,#ffffff,#ffffff,#719EFD\rp:Aqua Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 aqua_marquee\t#ffffff,#ffffff,#ffffff,#68DADA\rp:Red Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 red_marquee\t#ffffff,#ffffff,#ffffff,#C60000\rp:Purple Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 purple_marquee\t#ffffff,#ffffff,#ffffff,#D600E2\rp:Pink Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 pink_marquee\t#ffffff,#ffffff,#ffffff,#FF798F\rp:Navy Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 navy_marquee\t#ffffff,#ffffff,#ffffff,#004AA0\rp:White Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 white_marquee\t#ffffff,#ffffff,#ffffff,#ffffff\rp:Graphite Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 graphite_marquee\t#ffffff,#ffffff,#ffffff,#707070", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "46", QSql::In);
        query.bindValue(":model", "Mode", QSql::In);
        query.bindValue(":map", "i:Mode\rn:Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed\t0,0,#8FAEB0,#8FAEB0,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed\t0,0,0,#8FAEB0,#8FAEB0,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa\t0,0,0,0,#8FAEB0,#8FAEB0\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair\t0,0,#8FAEB0,#8FAEB0,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate\t0,0,0,#8FAEB0,#8FAEB0\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar\t0,0,#8FAEB0,#8FAEB0\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar\t0,#8FAEB0,0\rp:Dining Chair\tMetallic seating experience\t3\t\ts\tchair_polyfon\t0\t1,1\t3 mmchair\t0,0,0\rp:Large Coffee Table\tFor larger gatherings\t4\t\ts\ttable_polyfon\t0\t2,2\t4 modetable\t\rp:Large Dining Table\tFor larger gatherings\t4\t\ts\tsmooth_table_polyfon\t0\t2,2\t4 R2P\t\rp:Large Coffee Table\tFor larger gatherings\t3\t\ts\ttable_polyfon_med\t0\t2,2\t3 PMP\t0,0,0\rp:Small Coffee Table\tFor serving a stylish latte\t1\t\ts\ttable_polyfon_small\t0\t2,2\t1 PPP\t0,0,0\rp:Bookcase\tFor the arty pad\t4\t\ts\tshelves_polyfon\t0\t2,1\t4 KHP\t0,0,0\rp:Shelf\tTidy up\t1\t\ts\tstand_polyfon_z\t0\t1,1\t1 LTP\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "47", QSql::In);
        query.bindValue(":model", "Monoliths", QSql::In);
        query.bindValue(":map", "i:Monoliths\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Monotliths page.Take a pick of any colour and buy for only 25creds!\rw:\re:catalog_presents_teaser2,\rp:Black Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono\t#ffffff,#333333,#333333,#333333,#ffffff\rp:Blue Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_blue\t#ffffff,#4488ff,#4488ff,#4488ff,#ffffff\rp:Pink Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_pink\t#ffffff,#ffaaaa,#ffaaaa,#ffaaaa,#ffffff\rp:Aqua Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_aqua\t#ffffff,#aaffff,#aaffff,#aaffff,#ffffff\rp:White Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_white\t#ffffff,#ffffff,#ffffff, #ffffff,#ffffff\rp:Sky Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_sky\t#ffffff,#aaccff,#aaccff,#aaccff,#ffffff\rp:Jade Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_jade\t#ffffff,#99dd77,#99dd77,#99dd77,#ffffff\rp:Purple Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_purple\t#ffffff,#ff99cc,#ff99cc,#ff99cc,#ffffff\rp:Violet Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_violet\t#ffffff,#bb99ff,#bb99ff,#bb99ff,#ffffffp:Yellow Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_yellow\t#ffffff,#ffee66,#ffee66,#ffee66,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "48", QSql::In);
        query.bindValue(":model", "New Paper", QSql::In);
        query.bindValue(":map", "i:Spaces\rn:Spaces\rl:ctlg_spaces\rt1:Muur\rt2:Vloer\rt3:Patroon\rg:catalog_spaces_headline1\rt4:Kleur\rt5:Patroonn\rt6:Kleur\rt7:Voorbeeld\rh:Niet alleen met het meubilair in je kamer laat je zien wie je bent. Een lik verf op de muren of een pittig patroon in je vloerbedekking maakt het hele verschil. Gebruik onze virtuele kamer hieronder om de verschillende combi's te testen voor je iets koopt. Kies het patroon en de kleur die je leuk vind en klik  op 'Koop'.\re:\rp:floor\tFloor\t2\t\ti\tfloor\t\t\t2 l\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 1\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 2\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 3\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 4\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 5\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 6\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 7\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 8\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 9\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 10\t\t\t2 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 11\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 12\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 13\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 14\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 15\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 16\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 17\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 18\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 19\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 20\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 21\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 22\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 23\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 24\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 25\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 26\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 27\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 28\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 29\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 30\t\t\t5 t\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "49", QSql::In);
        query.bindValue(":model", "No Rares", QSql::In);
        query.bindValue(":map", "i:No Rares\rn:No Rares\rl:ctlg_norares\rh:There isn't a rare item to buy at the moment, but it's coming soon! Please don't email us about it - we're keeping it secret...\rg:catalog_rares_headline1\re:ctlg_norare_char1,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "50", QSql::In);
        query.bindValue(":model", "Offers", QSql::In);
        query.bindValue(":map", "i:Offers\rn:Offers\rl:ctlg_layout2\rs:\rh:Special Offers are great if you?re just starting out. Take a look at our special collections, all at a great price.<br><br>Check them out!\rg:catalog_deals_headline1\rw:Click on a deal to find out what's included and how much it costs.\re:catalog_deals_teaser1,\rp:Dining Chair\tKeep it simple\t5\t\td\t\t\t\tdeal01\t\t2\tchair_silo\t3\t#ffffff,#ffffff,#ABD0D2,#ABD0D2\ttable_silo_med\t1\t#ffffff,#ABD0D2\rp:Doormat\tWelcome Habbos in style\t5\t\td\t\t\t\tdeal02\t\t3\ttable_norja_med\t1\t#ffffff,#F7EBBC\tchair_norja\t2\t#ffffff,#ffffff,#F7EBBC,#F7EBBC\tdoormat_love\t1\t0,0,0\rp:Large Coffee Table\tFor larger gatherings\t5\t\td\t\t\t\tdeal03\t\t3\ttable_polyfon_med\t1\t0,0,0\tdoormat_plain\t1\t0,0,0\tchair_polyfon\t2\t0,0,0\rp:Shelf\tTidy up\t5\t\td\t\t\t\tdeal04\t\t3\tred_tv\t1\t\tchair_plasty*3\t1\t#ffffff,#ff2200,#ffffff,#ff2200\tstand_polyfon_z\t1\t0,0,0\rp:Chair\tHip plastic furniture\t5\t\td\t\t\t\tdeal05\t\t1\tchair_plasty*3\t6\t#ffffff,#533e10,#ffffff,#533e10\rp:Stool\tRustic charm at it's best\t5\t\td\t\t\t\tdeal06\t\t2\tsmall_table_armas\t1\t0,0,0\tsmall_chair_armas\t3\t0,0,0\rp:Chair\tHip plastic furniture\t5\t\td\t\t\t\tdeal07\t\t2\tchair_plasto*8\t4\t#ffffff,#c38d1a,#ffffff,#c38d1a\ttable_plasto_4leg*8\t1\t#ffffff,#c38d1a\rp:Doormat\tWelcome Habbos in style\t5\t\td\t\t\t\tdeal08\t\t4\tdoormat_love\t1\t0,0,0\ttable_silo_small\t1\t#ffffff,#ABD0D2\tcarpet_standard*a\t1\t#55AC00,#55AC00,#55AC00\tplant_sunflower\t1\t\rp:Queen Mum Poster\taw, bless...\t5\t\td\t\t\t\tdeal09\t\t3\tposter 1002\t1\t\tplant_pineapple\t1\t\tplant_fruittree\t2\t\rp:Prince Charles Poster\tEven walls have ears\t5\t\td\t\t\t\tdeal10\t\t3\tplant_fruittree\t2\t\tposter 1001\t1\t\tplant_pineapple\t1\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "51", QSql::In);
        query.bindValue(":model", "Oriental Screens", QSql::In);
        query.bindValue(":map", "i:Oriental Screens\rn:Oriental Screens\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the oriental Screens page. Here you can buy any oriental screen to give your room that Chinese feel!\rw:\re:catalog_presents_teaser2,\rp:Pink Oriental screen\tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 pink_screen\t#ffffff,#ffffff,#FFA795,#FFA795,#ffffff,#ffffff\rp:Purple Oriental Screen\tAdds an exotic vibe to any room\t  25\t\ts\twooden_screen*7\t0\t1,2\t3 purple_screen\t#ffffff,#ffffff,#DA2591,#DA2591,#ffffff,#ffffff\rp:Teal Oriental Screen \tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 teal_screen\t#ffffff,#ffffff,#004B5E,#004B5E,#ffffff,#ffffff\rp:Gray Oriental Screen\tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 gray_screen\t#ffffff,#ffffff,#778B61,#778B61,#ffffff,#ffffff\rp:Green Oriental Screen \tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 green_screen\tffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff\rp:Golden Oriental Screen\tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 golden_screen\t#ffffff,#ffffff,#F7B800,#F7B800,#ffffff,#ffffff\rp:Blue Oriental Screen \tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 blue_screen\t#ffffff,#ffffff,#72B6D1,#72B6D1,#ffffff,#ffffff\rp:Aqua Oriental Screen  \tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 aqua_screen\t#ffffff,#ffffff,#79E4B3,#79E4B3,#ffffff,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "52", QSql::In);
        query.bindValue(":model", "Paper", QSql::In);
        query.bindValue(":map", "i:Spaces\rn:Spaces\rl:ctlg_spaces\rt1:Muur\rt2:Vloer\rt3:Patroon\rg:catalog_spaces_headline1\rt4:Kleur\rt5:Patroonn\rt6:Kleur\rVoorbeeld\rh:Are your walls looking a little grey?  What you need is a splash of paint and this is the place to get it!  <br><br>A splash of colour on the walls and a nice carpet can make all the difference. Use our virtual room below to test out the combinations before you buy...\re:\rp:floor\tFloor\t2\t\ti\tfloor\t\t\t2 l\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 1\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 2\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 3\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 4\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 5\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 6\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 7\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 8\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 9\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 10\t\t\t2 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 11\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 12\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 13\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 14\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 15\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 16\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 17\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 18\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 19\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 20\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 21\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 22\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 23\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 24\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 25\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 26\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 27\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 28\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 29\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 30\t\t\t5 t\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "53", QSql::In);
        query.bindValue(":model", "Pet Accessories", QSql::In);
        query.bindValue(":map", "i:Pet Accessories\rn:Pet Accessories\rl:ctlg_layout2\rs:You'll have to share it!\rh:You'll need to take care of your pet to keep it happy and healthy. This section of the Catalogue has EVERYTHING you?ll need to satisfy your pet?s needs.  PLEASE NOTE:  No fish were harmed in the creating of this section!\rg:catalog_pet_headline2\rw:Click on the item you want for more information.\re:ctlg_pet_teaser1,\rp:Doggy Bones\tNatural nutrition for the barking one\t2\t\td\t\t\t\tdeal97\t\t1\tpetfood1\t6\t0,0\rp:Sardines\tFresh catch of the day\t2\t\td\t\t\t\tdeal98\t\t1\tpetfood2\t6\t0\r\r\rp:Cabbage\tHealth food for pets\t2\t\td\t\t\t\tdeal99\t\t1\tpetfood3\t6\t0,0,0\r\r\rp:T-Bones\tFor the croc!\t5\t\td\t\t\t\tdeal96\t\t1\tpetfood4\t6\t#ffffff,#533e10,#ffffff,#533e10\rp:T-Bone\tFor the croc!\t1\t\ts\tpetfood4\t2\t1,1\tA0 petfood4\t0,0\rp:Doggy Bones\tNatural nutrition for the barking one\t1\t\ts\tpetfood1\t2\t1,1\tA0 petfood1\t0,0\rp:Sardines\tFresh catch of the day\t1\t\ts\tpetfood2\t2\t1,1\tA0 petfood2\t0\rp:Cabbage\tHealth food for pets\t1\t\ts\tpetfood3\t2\t1,1\tA0 petfood3\t0,0,0\rp:Blue Water Bowl\tAqua unlimited\t2\t\ts\twaterbowl*4\t2\t1,1\tA0 waterbowlblue\t#0099ff,#ffffff,#ffffff\rp:Brown Water Bowl\tAqua unlimited\t2\t\ts\twaterbowl*5\t2\t1,1\tA0 waterbowlbrown\t#bf7f00,#ffffff,#ffffff\rp:Green Water Bowl\tAqua unlimited\t2\t\ts\twaterbowl*2\t2\t1,1\tA0 waterbowlgreen\t#3fff3f,#ffffff,#ffffff\rp:Red Water Bowl\tAqua unlimited\t2\t\ts\twaterbowl*1\t2\t1,1\tA0 waterbowlred\t#ff3f3f,#ffffff,#ffffff\rp:Yellow Water Bowl\tAqua unlimited\t2\t\ts\twaterbowl*3\t2\t1,1\tA0 waterbowlyellow\t#ffff00,#ffffff,#ffffff\rp:Chocolate Mouse\tFor gourmet kittens\t1\t\ts\tgoodie2\t2\t1,1\tA0 petgoodie2\t0\rp:Marzipan Man\tCrunchy Dog Treat\t1\t\ts\tgoodie1\t2\t1,1\tA0 petgoodie1a\t#ff4cbf,#ffffff\rp:Marzipan Man\tCrunchy Dog Treat\t1\t\ts\tgoodie1*1\t2\t1,1\tA0 petgoodie1b\t#3fffff,#ffffff\rp:Marzipan Man\tCrunchy Dog Treat\t1\t\ts\tgoodie1*2\t2\t1,1\tA0 petgoodie1c\t#ffbf00,#ffffff\rp:Rubber Ball\tit's bouncy-tastic\t2\t\ts\ttoy1\t2\t1,1\tA0 pettoy1\t#ff0000,#ffff00,#ffffff,#ffffff\rp:Rubber Ball\tit's bouncy-tastic\t2\t\ts\ttoy1*1\t2\t1,1\tA0 pettoy2\t#ff7f00,#007f00,#ffffff,#ffffff\rp:Rubber Ball\tit's bouncy-tastic\t2\t\ts\ttoy1*2\t2\t1,1\tA0 pettoy3\t#003f7f,#ff00bf,#ffffff,#ffffff\rp:Rubber Ball\tit's bouncy-tastic\t2\t\ts\ttoy1*3\t2\t1,1\tA0 pettoy4\t#bf1900,#00bfbf,#ffffff,#ffffff\rp:Rubber Ball\tit's bouncy-tastic\t2\t\ts\ttoy1*4\t2\t1,1\tA0 pettoy5\t#000000,#ffffff,#ffffff,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "54", QSql::In);
        query.bindValue(":model", "Pets", QSql::In);
        query.bindValue(":map", "i:Pets\rn:Pets\rl:ctlg_pets\rs:\rt2:\ru:Pets2\rw:Vind hier jouw dier!\rg:catalog_pet_headline1\rh:Pets..<br>NEW! Crocodiles!<br>\rt1:Choose a name:\re:catalog_pets_teaser1,\rp:Mand\tEen warm nest\t20\t\ts\tnest\t0\t1,1\ta0 pet0\t0,0,0\rp:Mand\tEen warm nest\t20\t\ts\tnest\t0\t1,1\ta0 pet1\t0,0,0\rp:Mand\tEen warm nest\t20\t\ts\tnest\t0\t1,1\ta0 pet2\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "55", QSql::In);
        query.bindValue(":model", "Pets2", QSql::In);
        query.bindValue(":map", "i:Pets2\rn:Pets2\rl:ctlg_pets2\rs:\rt2:-  Older pets sleep more.<br><br>-  Pets cannot be traded.<br><br>-  You can only put your pet in YOUR room.<br><br>-  You can only put TWO pets in a room. <br><br>-  Pick up the basket to pick up your pet.\rt3:\rt1:A Few Pet Things YOU Should Know:\rw:\rg:catalog_pet_headline1\rh:Every pet owner needs to know a few things about their fluffy friend, so they can take care of it properly.  If you're thinking of buying a pet, make sure you read the following points carefully. \re:ctlg_pet_note,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "56", QSql::In);
        query.bindValue(":model", "Pillars", QSql::In);
        query.bindValue(":map", "i:Pillars\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the pillars page. Here you can buy any pillar that will make your room feel like ancient Greek!\rw:\re:catalog_presents_teaser2,\rp:Greek Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*0\t1\t1,1\t3 greek_pillar\t#ffffff,#ffffff,#ffffff\rp:Atlantean Pillar\tRecovered from Habblantis\t25\t\ts\tpillar*7\t1\t1,1\t3 atlant_pillar\t#ffffff,#e3ca0e,#e3ca0e\rp:Terracotta Pillar\tAncient and stately\t25\t\ts\tpillar*6\t1\t1,1\t3 terra_pillar\t#ffffff,#972e2a,#972e2a\rp:Rock Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*9\t1\t1,1\t3 rock_pillar\t#ffffff,#B2A69D,#B2A69D\rp:Olive Green Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*8\t1\t1,1\t3 olive_pillar\t#ffffff,#9A924B,#9A924B\rp:Wood Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*2\t1\t1,1\t3 wood_pillar\t#ffffff,#7B5922,#7B5922\rp:Green Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*5\t1\t1,1\t3 green_pillar\t#ffffff,#CEDD65,#CEDD65\rp:Graphite Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*4\t1\t1,1\t3 graphite_pillar\t#ffffff,#71797C,#71797C\rp:Pink Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*0\t1\t1,1\t3 pink_pillar\t#ffffff,#FFD0D2,#FFD0D2p:Blue Pillar\tAncient and stately\t25\t\ts\tpillar*3\t0\t1,1\t3 blue_pillar\t#ffffff,#BDCDEA,#BDCDEA", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "57", QSql::In);
        query.bindValue(":model", "Pillows", QSql::In);
        query.bindValue(":map", "i:Pillows\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the pillows page. Here you can buy any colour pillow that will make your habbo comfortable!\rw:\re:catalog_presents_teaser2,\rp:Turquoise Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 turquoise_pillow\t#63C9A0,#63C9A0,#ffffff,#ffffff\rp:Blue Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 blue_pillow\t#5DAAC9,#5DAAC9,#ffffff,#ffffff\rp:Pink Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 pink_pillow\t#FF8888,#FF8888,#ffffff,#ffffff\rp:Navy Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 navy_pillow\t#214E68,#214E68,#ffffff,#ffffff\rp:Black Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 black_pillow\t#494D29,#494D29,#ffffff,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "58", QSql::In);
        query.bindValue(":model", "Pink Iced", QSql::In);
        query.bindValue(":map", "i:Pink Iced\rn:Pink Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_pink\t0,#DE7599,#DE7599,#DE7599\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_pink\t0,0,0,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_pink\t0,#DE7599\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_pink\t#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_pink\t0,#DE7599,#DE7599\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_pink\t#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_pink\t0,0,#DE7599,#DE7599,#DE7599,#DE7599\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_pink\t0,#DE7599,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_pink\t0,0,#DE7599,#DE7599,#DE7599,#DE7599\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_pink\t0,#DE7599,#DE7599,#DE7599,#DE7599\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_pink\t0,0,#DE7599,#DE7599", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "59", QSql::In);
        query.bindValue(":model", "Plants", QSql::In);
        query.bindValue(":map", "i:Plants\rn:Plants\rl:ctlg_layout2\rs:2: No Habbo here, just us trees...\rh:Introducing the Plant Collection...  Every room needs a plant! Not only do they bring a bit of the outside inside, they also enhance the air quality! \rg:catalog_plants_headline1\rw:Click on the item you want for more information.\re:catalog_plants_teaser1,\rp:Vase of Flowers\tGuaranteed to stay fresh\t4\t\ts\tgiftflowers\t0\t1,1\ta2 giftflowers\t0,0,0\rp:Cut Roses\tSleek and chic\t3\t\ts\tplant_rose\t0\t1,1\ta2 ruusu\t\rp:Cut Sunflower\tFor happy Habbos\t3\t\ts\tplant_sunflower\t0\t1,1\ta2 aurinko\t\rp:Yukka Plant\tEasy to care for\t3\t\ts\tplant_yukka\t0\t1,1\tA2 JUKKA\t\rp:Pineapple Plant\tNeeds loving glances\t3\t\ts\tplant_pineapple\t0\t1,1\tA1 ANANAS\t\rp:Bonsai Tree\tYou can be sure it lives\t3\t\ts\tplant_bonsai\t0\t1,1\tA2 BONSAI\t\rp:Mature Cactus\tHabbo Dreams monster in hiding!  Shhhh\t3\t\ts\tplant_big_cactus\t0\t1,1\tA2 ISOKAKTUS\t\rp:Small Cactus\tEven less watering than the real world\t1\t\ts\tplant_small_cactus\t0\t1,1\tA1 PIKKUKAKTUS\t\rp:Fruit Tree\tGreat yield and sweet fruit\t3\t\ts\tplant_fruittree\t0\t1,1\tA1 PUU\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "60", QSql::In);
        query.bindValue(":model", "Plastic", QSql::In);
        query.bindValue(":map", "i:Plastic\rn:Plastic\rl:ctlg_plasto\rt2:Select The Colour\rs:New colours!\rt3:Preview\rt1:Choose An Item\rw:Select an item and a colour and buy!\rg:catalog_plasto_headline1\rh:Introducing The Plastic Collection...  Can you feel that 1970s vibe?  Decorate with Plastic and add some colour to your life. Choose a colour that reflect your mood, or just pick your favourite shade.\re:\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*9\t0\t1,1\tA1 E9P\t#ffffff,#533e10,#ffffff,#533e10\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*16\t0\t1,1\ta1 newplch16\t#ffffff,#CC3399,#ffffff,#CC3399\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*15\t0\t1,1\ta1 newplch2\t#ffffff,#FF97BA,#ffffff,#FF97BA\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*5\t0\t1,1\tA1 E3P\t#ffffff,#54ca00,#ffffff,#54ca00\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto\t0\t1,1\tA1 EHP\t0,0,0\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*8\t0\t1,1\tA1 E7P\t#ffffff,#c38d1a,#ffffff,#c38d1a\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*7\t0\t1,1\tA1 E6P\t#ffffff,#ff6d00,#ffffff,#ff6d00\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*1\t0\t1,1\tA1 E1P\t#ffffff,#ff1f08,#ffffff,#ff1f08\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*4\t0\t1,1\tA1 E8P\t#ffffff,#ccddff,#ffffff,#ccddff\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*6\t0\t1,1\tA1 E2P\t#ffffff,#3444ff,#ffffff,#3444ff\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*3\t0\t1,1\tA1 E5P\t#ffffff,#ffee00,#ffffff,#ffee00\rp:Chair\tHip plastic furniture\t3\t\ts\tchair_plasto*2\t0\t1,1\tA1 E4P\t#ffffff,#99DCCC,#ffffff,#99DCCc\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*15\t0\t1,1\ta1 newplsq2\t#ffffff,#FF97BA\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*14\t0\t1,1\ta1 newplsq1\t#ffffff,#CC3399\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*1\t0\t1,1\tA1 B1P\t#ffffff,#ff1f08\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*7\t0\t1,1\tA1 B6P\t#ffffff,#ff6d00\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square\t0\t1,1\tA1 BHP\t0,0,0\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*2\t0\t1,1\tA1 B4P\t#ffffff,#99DCCC\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*4\t0\t1,1\tA1 B8P\t#ffffff,#ccddff\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*6\t0\t1,1\tA1 B2P\t#ffffff,#3444ff\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*3\t0\t1,1\tA1 B5P\t#ffffff,#ffee00\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*9\t0\t1,1\tA1 B9P\t#ffffff,#533e10\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*5\t0\t1,1\tA1 B3P\t#ffffff,#54ca00\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_square*8\t0\t1,1\tA1 B7P\t#ffffff,#c38d1a\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*15\t0\t2,2\ta1 newplrnd2\t#ffffff,#FF97BA\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*14\t0\t2,2\ta1 newplrnd1\t#ffffff,#CC3399\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*7\t0\t2,2\tA1 C6P\t#ffffff,#ff6d00\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*1\t0\t2,2\tA1 C1P\t#ffffff,#ff1f08\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*2\t0\t2,2\tA1 C4P\t#ffffff,#99DCCC\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*4\t0\t2,2\tA1 C8P\t#ffffff,#ccddff\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*6\t0\t2,2\tA1 C2P\t#ffffff,#3444ff\rp:Round Dining Table\tHip plastic furniture?\t3\t\ts\ttable_plasto_round*3\t0\t2,2\tA1 C5P\t#ffffff,#ffee00\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*9\t0\t2,2\tA1 C9P\t#ffffff,#533e10\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round\t0\t2,2\tA1 CHP\t0,0,0\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*5\t0\t2,2\tA1 C3P\t#ffffff,#54ca00\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_round*8\t0\t2,2\tA1 C7P\t#ffffff,#c38d1a\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*15\t0\t2,2\ta1 newplbsq2\t#ffffff,#FF97BA\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*14\t0\t2,2\ta1 newplbsq1\t#ffffff,#CC3399\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*7\t0\t2,2\tA1 D6P\t#ffffff,#ff6d00\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*1\t0\t2,2\tA1 D1P\t#ffffff,#ff1f08\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*2\t0\t2,2\tA1 D4P\t#ffffff,#99DCCC\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare\t0\t2,2\tA1 DHP\t0,0,0\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*8\t0\t2,2\tA1 D7P\t#ffffff,#c38d1a\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*5\t0\t2,2\tA1 D3P\t#ffffff,#54ca00\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*9\t0\t2,2\tA1 D9P\t#ffffff,#533e10\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*3\t0\t2,2\tA1 D5P\t#ffffff,#ffee00\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*6\t0\t2,2\tA1 D2P\t#ffffff,#3444ff\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_bigsquare*4\t0\t2,2\tA1 D8P\t#ffffff,#ccddff\rp:Occasional table Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*6\t0\t2,2\tA1 A2P\t#ffffff,#3444ff\rp:Square Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*1\t0\t2,2\tA1 A1P\t#ffffff,#ff1f08\rp:Round Dining Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*3\t0\t2,2\tA1 A5P\t#ffffff,#ffee00\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*9\t0\t2,2\tA1 A9P\t#ffffff,#533e10\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg\t0\t2,2\tA1 AHP\t0,0,0\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*5\t0\t2,2\tA1 A3P\t#ffffff,#54ca00\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*2\t0\t2,2\tA1 A4P\t#ffffff,#99DCCC\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*8\t0\t2,2\tA1 A7P\t#ffffff,#c38d1a\rp:Occasional table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*7\t0\t2,2\tA1 A6P\t#ffffff,#ff6d00\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*10\t0\t2,2\ta1 newa8p\t#ffffff,#ccddff\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*15\t0\t2,2\ta1 newpl4lg2\t#ffffff,#FF97BA\rp:Occasional Table\tHip plastic furniture\t3\t\ts\ttable_plasto_4leg*16\t0\t2,2\ta1 newpltb4lg16\t#ffffff,#CC3399\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty\t0\t1,1\tA2 PL1\t0,0,0\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*1\t0\t1,1\tA2 PL2\t#ffffff,#8EB5D1,#ffffff,#8EB5D1\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*2\t0\t1,1\tA2 PL3\t#ffffff,#ff9900,#ffffff,#ff9900\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*3\t0\t1,1\tA2 PL4\t#ffffff,#ff2200,#ffffff,#ff2200\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*4\t0\t1,1\tA2 PL5\t#ffffff,#00cc00,#ffffff,#00cc00\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*7\t0\t1,1\ta1 newplty1\t#ffffff,#99DCCc,#ffffff,#99DCCc\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*8\t0\t1,1\ta1 newplty2\t#ffffff,#c38d1a,#ffffff,#c38d1a\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*9\t0\t1,1\ta1 newplty3\t#ffffff,#533e10,#ffffff,#533e10\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*10\t0\t1,1\ta1 newplty4\t#ffffff,#CC3399,#ffffff,#CC3399\rp:Plastic Pod Chair\tHip plastic furniture\t3\t\ts\tchair_plasty*11\t0\t1,1\ta1 newplty5\t#ffffff,#FF97BA,#ffffff,#FF97BA", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "61", QSql::In);
        query.bindValue(":model", "Presents", QSql::In);
        query.bindValue(":map", "i:Presents\rn:Presents\rl:ctlg_presents\rt1:Buying an item as a gift couldn?t be simpler...  <br><br>Buy an item from the Catalogue in the normal way, but tick 'buy as a gift'. Tell us which Habbo you want to give the gift to and we'll gift wrap it and deliver it straight to their hand.\rg:catalog_gifts_headline1\rh:Show your Habbo friends just how much you care and send them a gift from the Habbo Catalogue.  ANY Catalogue item can be sent as a gift to ANY Habbo, all you need is their Habbo name!\re:catalog_presents_teaser1,catalog_presents_teaser2,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "62", QSql::In);
        query.bindValue(":model", "Pura", QSql::In);
        query.bindValue(":map", "i:Pura\rn:Pura\rl:ctlg_layout2\rs:2: Mini-Bar?  You naughty Habbo!\rw:Click on the item you want for more information.\rg:catalog_pura_headline1\rh:Introducing the Pura Collection...  This collection breathes fresh, clean air and cool tranquillity. Use it to create a special haven away from the hullabaloo of life outside the Hotel.\re:catalog_pura_teaser1,\rp:Plain Double Bed\tSweet dreams for two\t3\t\ts\tbed_budgetb\t0\t2,3\tA1 S2BVALKO\t\rp:Plain Single Bed\tAll you need for a good night?s kip\t3\t\ts\tbed_budgetb_one\t0\t2,3\tA1 S1BVALKO\t\rp:Plain Double Bed\tSweet dreams for two\t3\t\ts\tbed_budget\t0\t2,3\tA1 S2B\t0,0,0\rp:Plain Single Bed\tAll you need for a good night?s kip\t3\t\ts\tbed_budget_one\t0\t2,3\tA1 S1B\t0,0,0\rp:Pura Phelves\tPura series 404 shelves\t3\t\ts\tshelves_basic\t0\t2,1\ta2 bookcase\t0,0,0\rp:A Pura Minibar\tA pura series 300 minibar\t4\t\ts\tbar_basic\t0\t1,1\tA2 baba\tnull\rp:Pura Refridgerator\tKeep cool with a chilled snack or drink\t6\t\ts\tfridge\t0\t1,1\tA2 FDG\t0,0,0\rp:Pura Lamp\tSwitch on the atmosphere with this sophisticated light\t3\t\ts\tlamp_basic\t0\t1,1\tA1 BLMP\t0,0,0", QSql::In);
        query.exec();


        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "63", QSql::In);
        query.bindValue(":model", "Queue", QSql::In);
        query.bindValue(":map", "i:Queuen:Rollersl:ctlg_layout2s:h:Move your imagination. This cool stuff is more than suitable for business and pleasure... Habbo rollers for games and queues. Now available also in multipacks.g:catalog_roller_headline1w:Click on an item to see more detailse:p:Red Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*2\t0\t1,1\ta4 queue_red\t#ffffff,#FF3333,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Red Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal104p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Red Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal105p:Purple Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*7\t0\t1,1\ta9 queue_purple\t#ffffff,#FC5AFF,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Purple Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal108p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Purple Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal109p:Black Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*5\t0\t1,1\ta7 queue_black\t#ffffff,#555A37,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Oil Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal116p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Oil Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal117p:Ultramarine Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*8\t0\t1,1\ta10 queue_navy\t#ffffff,#1E8AA5,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Navy Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal118p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Navy Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal119p:Green Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*9\t0\t1,1\ta11 queue_green\t#ffffff,#9AFF60,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Grass Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal114p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Grass Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal115p:Gold Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*4\t0\t1,1\ta6 queue_gold\t#ffffff,#FFAA2B,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Gold Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal112p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Gold Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal113p:Blue Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*6\t0\t1,1\ta8 queue_blue\t#ffffff,#A2E8FA,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Blue Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal106p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Blue Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal107p:Aqua Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*3\t0\t1,1\ta5 queue_aqua\t#ffffff,#6ED0A7,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking the power of movement!\t1\t2: 3 Aqua Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal110p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 Aqua Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal111p:White Habbo Roller\tThe power of movement\t1\t\ts\tqueue_tile1*0\t0\t1,1\ta0 queue_white\t#ffffff,#ffffff,#ffffff,#ffffffp:Habbo Rollers 3-Pack\tPacking The Power Of Movement`\t1\t2: 3 White Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal100p:Habbo Rollers 5-Pack\tPacking the power of movement!\t1\t2: 5 White Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal101\r\n", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "64", QSql::In);
        query.bindValue(":model", "Rare", QSql::In);
        query.bindValue(":map", "i:No Rares\rn:No Rares\rl:ctlg_norares\rh:There isn't a rare item to buy at the moment, but it's coming this Easter Sunday! Have you're chance to decide what Rare it is! Vote in the Habbzo Poll\rg:catalog_rares_headline1\re:ctlg_norare_char1,", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "65", QSql::In);
        query.bindValue(":model", "Rare Trophies", QSql::In);
        query.bindValue(":map", "i:Rare Trophies\rn:Rare Trophies\rl:ctlg_trophies\rh:Reward your Habbo friends, or yourself with one of our fabulous glittering array of bronze, silver and gold trophies.<br><br>First choose the trophy model (click on the arrows to see all the different styles) and then the metal (click on the seal below the trophy). Type your inscription below and we'll engrave it on the trophy along with your name and today's date.<br>\rg:catalog_trophies_headline1\rt1:Type your inscription CAREFULLY, it's permanent!\re:\rp:Globe trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy3*3\t0\t1,1\ta0 prizetrophy3_b\t#ffffff,#ffffff,#996600\rp:Fish trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy4*3\t0\t1,1\ta0 prizetrophy4_b\t#ffffff,#ffffff,#996600\rp:Habbo trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy7*3\t0\t1,1\ta0 prizetrophy7_b\t#ffffff,#ffffff,#996600\rp:Champion trophy\tGlittery gold\t12\t\ts\tprizetrophy6*1\t0\t1,1\ta0 prizetrophy6_g\t#ffffff,#ffffff,#FFDD3F\rp:Habbo trophy\tGlittery gold\t12\t\ts\tprizetrophy7*1\t0\t1,1\ta0 prizetrophy7_g\t#ffffff,#ffffff,#FFDD3F\rp:Globe trophy\tGlittery gold\t12\t\ts\tprizetrophy3*1\t0\t1,1\ta0 prizetrophy3_g\t#ffffff,#ffffff,#FFDD3F\rp:Fish trophy\tGlittery gold\t12\t\ts\tprizetrophy4*1\t0\t1,1\ta0 prizetrophy4_g\t#ffffff,#ffffff,#FFDD3F\rp:Champion trophy\tShiny silver\t10\t\ts\tprizetrophy6*2\t0\t1,1\ta0 prizetrophy6_s\t#ffffff,#ffffff,#ffffff\rp:Globe trophy\tShiny silver\t10\t\ts\tprizetrophy3*2\t0\t1,1\ta0 prizetrophy3_s\t#ffffff,#ffffff,#ffffff\rp:Habbo trophy\tShiny silver\t10\t\ts\tprizetrophy7*2\t0\t1,1\ta0 prizetrophy7_s\t#ffffff,#ffffff,#ffffff\rp:Fish trophy\tShiny silver\t10\t\ts\tprizetrophy4*2\t0\t1,1\ta0 prizetrophy4_s\t#ffffff,#ffffff,#ffffff\rp:Champion trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy6*3\t0\t1,1\ta0 prizetrophy6_b\t#ffffff,#ffffff,#996600", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "66", QSql::In);
        query.bindValue(":model", "Rares", QSql::In);
        query.bindValue(":map", "i:Rares\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the rares page. Here you can buy any rare for just a few credits!\rw:\re:catalog_presents_teaser2,\rp:Throne\tImportant Habbos only\t25\t\ts\tthrone\t0\t1,1\t5 throne\t0,0,0\rp:Dragon Egg\tThe stuff of legend\t25\t\ts\tspyro\t0\t1,1\t10 dino\t0,0,0\rp:Typewriter\tWrite that bestseller\t25\t\ts\ttypingmachine\t0\t1,1\t7 typo\t0,0,0\rp:Gold Trophy\tGorgeously glittery\t25\t\ts\tprize1\t2\t1,1\t5 prize1\t0,0,0\rp:Silver Trophy\tNice and shiny\t25\t\ts\tprize2\t0\t1,1\t4 prize2\t0,0,0\rp:Bronse Trophy\tA weighty award\t25\t\ts\tprize3\t0\t1,1\t3 prize3\t0,0,0\rp:Petal Patch\tA little bit of outdoors indoors...\t25\t\ts\trare_daffodil_rug\t0\t2,2\t3 petal\t0,0,0\rp:Habbo Turntable\tFor the retro music-lover\t25\t\ts\tdjesko_turntable\t0\t1,1\t6 djdecks\t0,0,0\rp:Holopod\tAs if by magic...\t25\t\ts\thologram\t0\t1,1\t3 holoboy\t0,0,0\rp:Holo-girl\tYou're her only hope...\t25\t\ts\tredhologram\t0\t1,1\t3 hologirl\t0,0,0\rp:Russian Samovar\tClick for a refreshing cuppa\t25\t\ts\tsamovar\t0\t1,1\t5 samovar\t0,0,0\rp:Habbo Cola Machine\tA sparkling and refreshing pixel drink!\t25\t\ts\tmd_limukaappi\t0\t1,1\t3 cola\t0,0,0\rp:Fire Dragon Lamp\tScary & Scorching!\t25\t\ts\trare_dragonlamp*0\t0\t1,1\t3 drag1\t#ffffff,#fa2d00,#fa2d00\rp:Sea Dragon Lamp\tOut of the deepes blue sea\t25\t\ts\trare_dragonlamp*1\t0\t1,1\t3 drag2\t#ffffff,#3470ff,#3470ff\rp:Jade Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*2\t0\t1,1\t3 drag3\t#ffffff,#02bb70,#02bb70\rp:Silver Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*3\t0\t1,1\t3 drag4\t#ffffff,#ffffff,#ffffff\rp:Black Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*4\t0\t1,1\t3 drag5\t#ffffff,#3e3d40,#3e3d40\rp:Elf Green Dragon Lamp\tRoast your chestnuts here!\t25\t\ts\trare_dragonlamp*5\t0\t1,1\t3 drag6\t#ffffff,#589a03,#589a03\rp:Gold Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*6\t0\t1,1\t3 drag7\t#ffffff,#ffbc00,#ffbc00\rp:Sky Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*7\t0\t1,1\t3 drag8\t#ffffff,#83aeff,#83aeff\rp:Bronze Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*8\t0\t1,1\t3 drag9\t#ffffff,#ff5f01,#ff5f01\rp:Purple Dragon Lamp\tScary and scorching!\t25\t\ts\trare_dragonlamp*9\t0\t1,1\t3 drag10\t#FFFFFF,#B357FF,#B357FF\rp:Disco Sign\tSerious partying going on!\t15\t\ti\tposter 56\t\t\tposter 56\t\rp:Blue Bear Rug\tSnuggle up on a Funky bear rug...\t10\t\ts\tcarpet_polar*2\t0\t2,3\tA2 blue_bear\t#ccddff,#ccddff,#ffffff\rp:Green Bear Rug\tSnuggle up on a Funky bear rug...\t10\t\ts\tcarpet_polar*4\t0\t2,3\tA2 green_bear\t#ddffaa,#ddffaa,#ffffff\rp:Yellow Bear Rug\tSnuggle up on a Funky bear rug...\t10\t\ts\tcarpet_polar*3\t0\t2,3\tA2 yellow_bear\t#ffee99,#ffee99,#ffffff\rp:Aloe Vera\tGoodbye Bert...\t25\t\ts\tplant_cruddy\t0\t1,1\t5 plant_cruddy\t0,0,0\rp:Hammock\tEco bed\t25\t\ts\trare_hammock\t0\t1,3\t5 rare_hammock\t0,0,0\rp:Holiday Romance\tPeep through and smile!\t25\t\ts\tvalentinescreen\t0\t2,1\t5 valentinescreen\t0,0,0\rp:Lappland Greetings\tHo Ho Ho!\t25\t\ts\trare_xmas_screen\t0\t2,1\t5 rare_xmas_screen\t0,0,0\rp:Green Parasol\tBlock those rays!\t25\t\ts\trare_parasol*0\t0\t1,1\t5 green_para\t#ffffff,#ffffff,#ffffff,#94f718\rp:Yellow Parasol\tBlock those rays!\t25\t\ts\trare_parasol*1\t0\t1,1\t5 yellow_para\t#ffffff,#ffffff,#ffffff,#ffff11\rp:Violet Parasol\tBlock those rays!\t25\t\ts\trare_parasol*3\t0\t1,1\t5 violet_para\t#ffffff,#ffffff,#ffffff,#d47fff\rp:Orange Parasol\tBlock those rays!\t25\t\ts\trare_parasol*2\t0\t1,1\t5 orange_para\t#ffffff,#ffffff,#ffffff,#ff8f61\rp:Bird Bath (green)\tFor our feathered friends\t25\t\ts\trare_fountain*2\t0\t1,1\t5 green_bath\t#ffffff,#ffffff,#b8cf00\rp:Bird Bath (grey)\tFor our feathered friends\t25\t\ts\trare_fountain*1\t0\t1,1\t5 grey_bath\t#ffffff,#ffffff,#ffffff\rp:Bird Bath (red)\tFor our feathered friends\t25\t\ts\trare_fountain\t0\t1,1\t5 red_bath\t#ffffff,#ffffff,#ef5a5a\rp:Bird Bath (blue)\tFor our feathered friends\t25\t\ts\trare_fountain*3\t0\t1,1\t5 blue_bath\t#ffffff,#ffffff,#52bdbd\rp:Golden Elephant\tSay hello to Nelly\t25\t\ts\trare_elephant_statue\t0\t1,1\t5 gold_elephant\t#ffffff,#ffcc00\rp:Silver Elephant\tSay hello to Nelly\t25\t\ts\trare_elephant_statue*1\t0\t1,1\t5 silver_elephant\t#ffffff,#bfbfbf\rp:Bronze Elephant\tSay hello to Nelly\t25\t\ts\trare_elephant_statue*2\t0\t1,1\t5 bronze_elephant\t#ffffff,#cc6600\rp:Blue Amber Lamp\tA honey-hued glow\t25\t\ts\trare_beehive_bulb\t0\t1,1\t5 blue_amber\t#ffffff,#ffffff,#ffffff,#ffffff,#55c4de,#ffffff\rp:Red Amber Lamp\tA honey-hued glow\t25\t\ts\trare_beehive_bulb*1\t0\t1,1\t5 red_amber\t#ffffff,#ffffff,#ffffff,#ffffff,#de5555,#ffffff\rp:Yellow Amber Lamp\tA honey-hued glow\t25\t\ts\trare_beehive_bulb*2\t0\t1,1\t5 yellow_amber\t#ffffff,#ffffff,#ffffff,#ffffff,#ffcc00,#ffffff\rp:Speaker's Corner\tStand and Deliver!\t25\t\ts\trare_stand\t0\t1,1\t5 speaker\t0,0,0\rp:Snow Globe\tIt's all white..\t25\t\ts\trare_globe\t0\t1,1\t5 rare_globe\t0,0,0\rp:Red Silk Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*2\t1\t1,1\t3 red_pillow\t#ef0000,#ffffff,#ffffff\rp:Green Wooly Pillow\tPuffy, soft and VERY fluffy!\t25\t\ts\tpillow*2\t1\t1,1\t3 green_pillow\t#b8ff4a,#ffffff,#ffffff\rp:White Lace Pillow\tMinimalist comfort!\t25\t\ts\tpillow*0\t1\t1,1\t3 white_pillow\t#ffffff,#ffffff,#ffffff\rp:Bonnie?s Pillow\tFor Habbo Stars only!\t25\t\ts\tpillow*7\t1\t1,1\t3 bonnie_pillow\t#e431c9,#ffffff,#ffffff\rp:Gold Feather Pillow\tPuffy, soft and huge\t25\t\ts\tpillow*4\t1\t1,1\t3 gold_pillow\t#ffbd10,#ffffff,#ffffff\rp:Gold Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*5\t1\t1,1\t3 gold_ice\t#FFFFFF,#E1CC00\rp:Purple Ice Cream Maker\tVirtual vanilla rocks!\t25\t\ts\trare_icecream*3\t1\t1,1\t3 purple_ice\t#FFFFFF,#B357FF\rp:White Oriental Screen\tAdd an exotic touch to your room\t25\t\ts\twooden_screen*0\t1\t1,2\t3 white_screen\t#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:RosewoodScreen\tAdd an exotic touch to your room\t25\t\ts\twooden_screen*2\t1\t1,2\t3 rosewood_screen\t#ffffff,#ffffff,#bb0000,#bb0000,#ffffff,#ffffff\rp:Yellow Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*4\t1\t1,1\t3 yellow_marquee\t#ffffff,#ffffff,#ffffff,#efbf00\rp:Green Marquee\tIt's both door and a shade!\t25\t\ts\tmarquee*9\t1\t1,1\t3 green_marquee\t#ffffff,#ffffff,#ffffff,#89ca35\rp:Alien Artifact  # 1337\tFrom the unknown depths of space\t25\t\ts\tscifirocket*5\t1\t1,1\t3 1337_rocket\t#ffffff,#ffffff,#555555,#ffffff\rp:White Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 white_rocket\t#ffffff,#ffffff,#ffffff,#ffffff\rp:Black Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono\t#ffffff,#333333,#333333,#333333,#ffffff\rp:Greek Pillar\tClassy architect, for holding up ceilings!\t25\t\ts\tpillar*0\t1\t1,1\t3 greek_pillar\t#ffffff,#ffffff,#ffffff\rp:Atlantean Pillar\tRecovered from Habblantis\t25\t\ts\tpillar*7\t1\t1,1\t3 atlant_pillar\t#ffffff,#e3ca0e,#e3ca0e\rp:Terracotta Pillar\tAncient and stately\t25\t\ts\tpillar*6\t1\t1,1\t3 terra_pillar\t#ffffff,#972e2a,#972e2a\rp:Festive Fan\tAs red as Rudolph's nose\t25\t\ts\trare_fan*0\t1\t1,1\t3 fest_fan\t#F43100,0,0,0\rp:SUPERLOVE Fan\tFanning the fires of SUPERLOVE...\t25\t\ts\trare_fan*4\t1\t1,1\t3 love_fan\t#e78b8b,0,0,0\rp:Snow Rug\tLet's get sporty!\t25\t\ts\trare_snowrug\t0\t2,2\t3 snow\t0,0,0\rp:Moon Rug\tMade in 1969\t25\t\ts\trare_moonrug\t0\t2,2\t3 moon\t0,0,0\rp:Jamaican Sand Patch\tYour own paradise island\t25\t\ts\tsandrug\t0\t2,2\t3 sand\t0,0,0\rp:Infobus\tThe Special Infobus Poster\t15\t\ti\tposter 2005\t\t\tposter 2005\t\rp:Red Laser Door\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*0\t1\t1,1\t3 red_laser\t#ffffff,#d02a1f,#ffffff,#ffffff,#ffffff,#d02a1f\rp:Yellow Laser Door\tEnergy beams. No trespassers!\t25\t\ts\tscifiport*1\t1\t1,1\t3 yellow_laser\t#ffffff,#f1b000,#ffffff,#ffffff,#ffffff,#f1b000\rp:White Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*0\t0\t1,1\ta4 queue_white\t#ffffff,#ffffff,#ffffff,#ffffff\rp:Aqua Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*3\t0\t1,1\ta4 queue_aqua\t#ffffff,#67c39c,#ffffff,#ffffff\rp:Inflatable Chair\tSoft and tearproof!\t25\t\ts\trubberchair\t0\t1,1\t5 rubber_chair\t#CFCFCF,0,0\rp:Sleeping bag\tUltimate Coziness\t25\t\ts\tsleepingbag\t0\t1,3\t5 sleepingbag\t#BB5F54,0,#BB5F54,0,#BB5F54\rp:Road Barrier\tNo trespassing, please!\t25\t\ts\tbarrier\t0\t1,2\t5 barrier\t0,0,#FFC927,#FFC927\rp:Traffic Lights\tChill and wait your turn\t25\t\ts\ttraffic_light\t0\t1,1\t5 traffic_light\t0,#D91E26,0\rp:Solarium\tRejuvenate your pixels!\t25\t\ts\tsolarium_norja\t0\t1,1\t5 solarium_norja\t0,#E2DAAC\rp:Red Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t1\t1,1\t3 mono_red\t#ffffff,#8B0F01,#8B0F01,#8B0F01,#ffffff\rp:Area Master Desk\tFor the true Habbo Scholars\t3\t\ts\tsilo_studydesk\t0\t2,1\t3 silo_studydesk\t0,0\rp:Maze Shrubbery Gate\tLol maze.\t7\t\ts\tplant_mazegate\t0\t2,1\ta4 mazegate\t#ffffff,#ffffff,#ffffff,#ffffff\rp:Maze Shrubbery Thing\tLol maze.\t7\t\ts\tplant_maze\t0\t2,1\ta4 maze\t#ffffff,#ffffff,#ffffff,#ffffff\rp:Bulrushes\tAll nature n stuff...\t7\t\ts\tplant_bulrush\t0\t1,1\ta4 bulrush\t#ffffff,#ffffff,#ffffff,#ffffff\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "67", QSql::In);
        query.bindValue(":model", "Recoloured Area", QSql::In);
        query.bindValue(":map", "i:Recoloured Area\rn:Recoloured Area\rl:ctlg_layout2\rs:\rh:Area furni.\rg:catalog_area_headline1\rw:Click an item for more details.\re:catalog_area_teaser1,\rp:Red Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 redarea/gate\t#ffffff,#ffffff,#ffffff,#ba0000\rp:Red Occassional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 redarea/occasional_table\t#ffffff,#ba0000\rp:Red Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 redarea/coffee_table\t#ffffff,#ba0000\rp:Red Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 redarea/armchair\t#ffffff,#ffffff,#ba0000,#ba0000\rp:Red Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 redarea/dining_chair\t#ffffff,#ffffff,#ba0000,#ba0000\rp:Red Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 redarea/corner_shelf\t#ffffff,#ba0000\rp:Red Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 redarea/sofa\t#ffffff,#ffffff,#ffffff,#ffffff,#ba0000,#ba0000,#ba0000,#ba0000\rp:Green Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 greenarea/gate\t#ffffff,#ffffff,#ffffff,#18780e\rp:Green Occassional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 greenarea/occasional_table\t#ffffff,#18780e\rp:Green Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 greenarea/coffee_table\t#ffffff,#18780e\rp:Green Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 greenarea/armchair\t#ffffff,#ffffff,#18780e,#18780e\rp:Green Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 greenarea/dining_chair\t#ffffff,#ffffff,#18780e,#18780e\rp:Green Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 greenarea/corner_shelf\t#ffffff,#18780e\rp:Green Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 greenarea/sofa\t#ffffff,#ffffff,#ffffff,#ffffff,#18780e,#18780e,#18780e,#18780e\rp:Black Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 blackarea/gate\t#ffffff,#ffffff,#ffffff,#333333\rp:Black Occassional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 blackarea/occasional_table\t#ffffff,#333333\rp:Black Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 blackarea/coffee_table\t#ffffff,#333333\rp:Black Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 blackarea/armchair\t#ffffff,#ffffff,#333333,#333333\rp:Black Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 blackarea/dining_chair\t#ffffff,#ffffff,#333333,#333333\rp:Black Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 blackarea/corner_shelf\t#ffffff,#333333\rp:Black Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 blackarea/sofa\t#ffffff,#ffffff,#ffffff,#ffffff,#333333,#333333,#333333,#333333\rp:Blue Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 bluearea/gate\t#ffffff,#ffffff,#ffffff,#1c6caa\rp:Blue Occassional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 bluearea/occasional_table\t#ffffff,#1c6caa\rp:Blue Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 bluearea/coffee_table\t#ffffff,#1c6caa\rp:Blue Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 bluearea/armchair\t#ffffff,#ffffff,#1c6caa,#1c6caa\rp:Blue Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 bluearea/dining_chair\t#ffffff,#ffffff,#1c6caa,#1c6caa\rp:Blue Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 bluearea/corner_shelf\t#ffffff,#1c6caa\rp:Blue Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 bluearea/sofa\t#ffffff,#ffffff,#ffffff,#ffffff,#1c6caa,#1c6caa,#1c6caa,#1c6caa\rp:White Gate (lockable)\tForm following function\t6\t\ts\tdivider_silo3\t0\t1,1\ta2 whitearea/gate\t#ffffff,#ffffff,#ffffff,#ffffff\rp:White Occassional Table\tFor those random moments\t1\t\ts\ttable_silo_small\t0\t1,1\tA1 whitearea/occasional_table\t#ffffff,#ffffff\rp:White Coffee Table\tWipe clean and unobtrusive\t3\t\ts\ttable_silo_med\t0\t2,2\tA1 whitearea/coffee_table\t#ffffff,#ffffff\rp:White Armchair\tLarge, but worth it\t3\t\ts\tsofachair_silo\t0\t1,1\tA1 whitearea/armchair\t#ffffff,#ffffff,#ffffff,#ffffff\rp:White Dining Chair\tKeep it simple\t3\t\ts\tchair_silo\t0\t1,1\tA1 whitearea/dining_chair\t#ffffff,#ffffff,#ffffff,#ffffff\rp:White Corner Shelf\tNeat and natty\t3\t\ts\tdivider_silo1\t0\t1,1\ta1 whitearea/corner_shelf\t#ffffff,#ffffff\rp:White Two-Seater Sofa\tCushioned, understated comfort\t3\t\ts\tsofa_silo\t0\t2,1\tA1 whitearea/sofa\t#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "68", QSql::In);
        query.bindValue(":model", "Recoloured Iced", QSql::In);
        query.bindValue(":map", "i:Recoloured Iced\rn:Recoloured Iced\rl:ctlg_layout2\rs:2: LAWL RECOLOUR.\rh:Iced furni, kai? \rg:catalog_iced_headline1\rw:Click on an item for more details.\re:catalog_iced_teaser1,\rp:Blue Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 blueiced/HYN\t#ffffff,#2f627d\rp:Blue Iced Auto Shutter\tHabbos, roll out!\t10\t\ts\tdivider_nor4\t0\t2,1\ta0 blueiced/nordiv4\t#ffffff,#ffffff,#2f627d,#2f627d,#2f627d,#2f627d\rp:Blue iced Angle\tCool cornering for your crib y0!\t8\t\ts\tdivider_nor5\t0\t1,1\ta0 blueiced/nordiv5\t#ffffff,#2f627d,#2f627d\r\rp:Blue Iced Sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 blueiced/PSN\t#ffffff,#2f627d,#ffffff,#2f627d,#2f627d,#2f627d\rp:Blue Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 blueiced/norkp\t#ffffff,#2f627d\rp:Blue Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 blueiced/nordiv\t#ffffff,#ffffff,#2f627d,#2f627d\rp:Blue Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 blueiced/PYN\t#ffffff,#2f627d\rp:Blue Iced Sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 blueiced/stn\t#ffffff,#2f627d,#2f627d\rp:Blue Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 blueiced/PEN\t#ffffff,#ffffff,#ffffff,#ffffff,#2f627d,#2f627d,#2f627d,#2f627d\rp:Blue Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 blueiced/TUN\t#ffffff,#ffffff,#2f627d,#2f627d\rp:Red Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 rediced/HYN\t#ffffff,#ba0000\rp:Red Iced Auto Shutter\tHabbos, roll out!\t10\t\ts\tdivider_nor4\t0\t2,1\ta0 rediced/nordiv4\t#ffffff,#ffffff,#ba0000,#ba0000,#ba0000,#ba0000\rp:Red iced Angle\tCool cornering for your crib y0!\t8\t\ts\tdivider_nor5\t0\t1,1\ta0 rediced/nordiv5\t#ffffff,#ba0000,#ba0000\r\rp:Red Iced Sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 rediced/PSN\t#ffffff,#ba0000,#ffffff,#ba0000,#ba0000,#ba0000\rp:Red Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 rediced/norkp\t#ffffff,#ba0000\rp:Red Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 rediced/nordiv\t#ffffff,#ffffff,#ba0000,#ba0000\rp:Red Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 rediced/PYN\t#ffffff,#ba0000\rp:Red Iced Sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 rediced/stn\t#ffffff,#ba0000,#ba0000\rp:Red Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 rediced/PEN\t#ffffff,#ffffff,#ffffff,#ffffff,#ba0000,#ba0000,#ba0000,#ba0000\rp:Red Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 rediced/TUN\t#ffffff,#ffffff,#ba0000,#ba0000\rp:Black Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 blackiced/HYN\t#ffffff,#333333\rp:Black Iced Auto Shutter\tHabbos, roll out!\t10\t\ts\tdivider_nor4\t0\t2,1\ta0 blackiced/nordiv4\t#ffffff,#ffffff,#333333,#333333,#333333,#333333\rp:Black iced Angle\tCool cornering for your crib y0!\t8\t\ts\tdivider_nor5\t0\t1,1\ta0 blackiced/nordiv5\t#ffffff,#333333,#333333\r\rp:Black Iced Sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 blackiced/PSN\t#ffffff,#333333,#ffffff,#333333,#333333,#333333\rp:Black Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 blackiced/norkp\t#ffffff,#333333\rp:Black Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 blackiced/nordiv\t#ffffff,#ffffff,#333333,#333333\rp:Black Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 blackiced/PYN\t#ffffff,#333333\rp:Black Iced Sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 blackiced/stn\t#ffffff,#333333,#333333\rp:Black Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 blackiced/PEN\t#ffffff,#ffffff,#ffffff,#ffffff,#333333,#333333,#333333,#333333\rp:Black Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 blackiced/TUN\t#ffffff,#ffffff,#333333,#333333\rp:Green Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 greeniced/HYN\t#ffffff,#3e6713\rp:Green Iced Auto Shutter\tHabbos, roll out!\t10\t\ts\tdivider_nor4\t0\t2,1\ta0 greeniced/nordiv4\t#ffffff,#ffffff,#3e6713,#3e6713,#3e6713,#3e6713\rp:Green iced Angle\tCool cornering for your crib y0!\t8\t\ts\tdivider_nor5\t0\t1,1\ta0 greeniced/nordiv5\t#ffffff,#3e6713,#3e6713\rp:Green Gate Thing\tLol green gate\t8\t\ts\tdivider_nor3\t0\t1,1\ta0 greeniced/norovi\t#ffffff,#ffffff,#ffffff,#3e6713\rp:Green Iced Sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 greeniced/PSN\t#ffffff,#3e6713,#ffffff,#3e6713,#3e6713,#3e6713\rp:Green Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 greeniced/norkp\t#ffffff,#3e6713\rp:Green Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 greeniced/nordiv\t#ffffff,#ffffff,#3e6713,#3e6713\rp:Green Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 greeniced/PYN\t#ffffff,#3e6713\rp:Green Iced Sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 greeniced/stn\t#ffffff,#3e6713,#3e6713\rp:Green Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 greeniced/PEN\t#ffffff,#ffffff,#ffffff,#ffffff,#3e6713,#3e6713,#3e6713,#3e6713\rp:Green Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 greeniced/TUN\t#ffffff,#ffffff,#3e6713,#3e6713", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "69", QSql::In);
        query.bindValue(":model", "Recycler", QSql::In);
        query.bindValue(":map", "i:Recycler\rn:Recycler\rl:ctlg_layout2\rg:catalog_recycler_headline1\rw:Click the item you want for more information.\rh:All Furni on this page is made from old, dusty Furni, it's recycled by YOU. Thank you for keeping to Hotel clean of old Furni. \re:catalog_recycler_teaser1,\rp:Recycler Sofa\tHandmade..\t25\t\ts\trclr_sofa\t0\t2,1\ta3 rclr_sofa\t0,0,0\rp:Recycler Chair\tHandmade..\t25\t\ts\trclr_chair\t0\t1,1\ta3 rclr_chair\t0,0,0\rp:Recycler Garden\tGive them water!\t25\t\ts\trclr_garden\t0\t1,3\ta0 rclr_garden\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "70", QSql::In);
        query.bindValue(":model", "Red Iced", QSql::In);
        query.bindValue(":map", "i:Red Iced\rn:Red Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_red\t0,#D23D16,#D23D16,#D23D16\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_red\t0,0,0,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_red\t0,#D23D16\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_red\t#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_red\t0,#D23D16,#D23D16\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_red\t#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_red\t0,0,#D23D16,#D23D16,#D23D16,#D23D16\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_red\t0,#D23D16,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_red\t0,0,#D23D16,#D23D16,#D23D16,#D23D16\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_red\t0,#D23D16,#D23D16,#D23D16,#D23D16\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_red\t0,0,#D23D16,#D23D16", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "71", QSql::In);
        query.bindValue(":model", "Red Mode", QSql::In);
        query.bindValue(":map", "i:Red Mode\rn:Red Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed_red\t0,0,#FFC927,#FFC927,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed_red\t0,0,0,#FFC927,#FFC927,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa_red\t0,0,0,0,#FFC927,#FFC927\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair_red\t0,0,#FFC927,#FFC927,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate_red\t0,0,0,#FFC927,#FFC927\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar_red\t0,0,#FFC927,#FFC927\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar_red\t0,#FFC927,0\rp:Dining Chair\tMetallic seating experience\t3\t\ts\tchair_polyfon\t0\t1,1\t3 mmchair\t0,0,0\rp:Large Coffee Table\tFor larger gatherings\t4\t\ts\ttable_polyfon\t0\t2,2\t4 modetable\t\rp:Large Dining Table\tFor larger gatherings\t4\t\ts\tsmooth_table_polyfon\t0\t2,2\t4 R2P\t\rp:Large Coffee Table\tFor larger gatherings\t3\t\ts\ttable_polyfon_med\t0\t2,2\t3 PMP\t0,0,0\rp:Small Coffee Table\tFor serving a stylish latte\t1\t\ts\ttable_polyfon_small\t0\t2,2\t1 PPP\t0,0,0\rp:Bookcase\tFor the arty pad\t4\t\ts\tshelves_polyfon\t0\t2,1\t4 KHP\t0,0,0\rp:Shelf\tTidy up\t1\t\ts\tstand_polyfon_z\t0\t1,1\t1 LTP\t0,0,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "72", QSql::In);
        query.bindValue(":model", "Rollers", QSql::In);
        query.bindValue(":map", "i:Rollers\rn:Rollers\rl:ctlg_layout2\rs:You can fit 35 Rollers in a Guest Room!\rw:Click on a Roller to see more information!\rg:catalog_roller_headline1\rh:Move your imagination, while you move your Habbo!  Perfect for mazes, games, for keeping your queue moving or making your pet go round in circles for hours.  Available in multi-packs ? the more you buy the cheaper the Roller!\re:\rp:Red Habbo Roller\tThe power of movement\t25\t2: 5 Red Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal105\t\t1\tqueue_tile1*2\t5\t#ffffff,#FF3333,#ffffff,#ffffff\rp:Red Habbo Roller\tThe power of movement\t15\t2: 3 Red Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal104\t\t1\tqueue_tile1*2\t3\t#ffffff,#FF3333,#ffffff,#ffffff\rp:Red Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*2\t0\t1,1\ta4 queue_red\t#ffffff,#FF3333,#ffffff,#ffffff\rp:Blue Habbo Roller\tThe power of movement\t25\t2: 5 Blue Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal107\t\t1\tqueue_tile1*6\t5\t#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Blue Habbo Roller\tThe power of movement\t15\t2: 3 Blue Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal106\t\t1\tqueue_tile1*6\t3\t#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Blue Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*6\t0\t1,1\ta8 queue_blue\t#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Green Habbo Roller\tThe power of movement\t25\t2: 5 Green Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal115\t\t1\tqueue_tile1*9\t5\t#ffffff,#9AFF60,#ffffff,#ffffff\rp:Green Habbo Roller\tThe power of movement\t15\t2: 3 Green Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal114\t\t1\tqueue_tile1*9\t3\t#ffffff,#9AFF60,#ffffff,#ffffff\rp:Green Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*9\t0\t1,1\ta11 queue_green\t#ffffff,#9AFF60,#ffffff,#ffffff\rp:Navy Habbo Roller\tThe power of movement\t25\t2: 5 Navy Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal119\t\t1\tqueue_tile1*8\t5\t#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Navy Habbo Roller\tThe power of movement\t15\t2: 3 Navy Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal118\t\t1\tqueue_tile1*8\t3\t#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Navy Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*8\t0\t1,1\ta10 queue_navy\t#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Purple Habbo Roller\tThe power of movement\t25\t2: 5 Purple Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal109\t\t1\tqueue_tile1*7\t5\t#ffffff,#FC5AFF,#ffffff,#ffffff\rp:Purple Habbo Roller\tThe power of movement\t15\t2: 3 Purple Habbo Rollers in a convenient Pack\td\t\t\t\ta0 deal108\t\t1\tqueue_tile1*7\t3\t#ffffff,#FC5AFF,#ffffff,#ffffff\rp:Purple Habbo Roller\tThe power of movement\t7\t\ts\tqueue_tile1*7\t0\t1,1\ta9 queue_purple\t#ffffff,#FC5AFF,#ffffff,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "73", QSql::In);
        query.bindValue(":model", "Romantique", QSql::In);
        query.bindValue(":map", "i:Romantique\rn:Romantique\rl:ctlg_layout2\rs:2: It's my piano!\rw:Click on the item you want for more information.\rg:catalog_romantique_headline1\rh:Exclusive: the new romantique furni line. Only at Habbo!\re:catalog_romantique_teaser1,\rp:Grand Piano\tGrand Piano\t5\t\ts\tgrand_piano*1\t0\t2,2\ta0 grand_piano\t#fffffff,#ff3366,#ffffff\rp:Romantque Pianochair\tRomantique Pianochair\t3\t\ts\tromantique_pianochair\t0\t1,1\ta0 pianochair\t#ffffff,#ff3366,#ffffff\rp:Romantique Divan\tRomantique Divan\t4\t\ts\tromantique_divan*1\t0\t2,1\ta0 romantique_divan\t#ffffff,#ffffff,#ffffff,#ff3366\rp:Romantique Divider\tRomantique Divider\t3\t\ts\tromantique_divider*1\t0\t2,1\ta0 romantique_divider\t#ff3366,#ff3366,#ffffff,#ffffff\rp:Romantique Tray 1\tRomantique Tray 1\t3\t\ts\tromantique_tray1\t0\t1,1\ta6 romantique_tray1\t0,0,0\rp:Romantique Tray 2\tRomantique Tray 2\t3\t\ts\tromantique_tray2\t0\t1,1\ta6 romantique_tray2\t0,0,0\rp:Romantique Chair\tRomantique Chair\t3\t\ts\tromantique_chair*1\t0\t1,1\ta6 romantique_chair\t#ffffff,#ff3366,#ffffff\rp:Romantique Lamp\tRomantique Lamp\t3\t\ts\trom_lamp\t0\t1,1\ta6 rom_lamp\t0,0,0\rp:Mirror\tMirror\t10\t\ti\twallmirror\t\t\ta0 wallmirror\t\rp:Cauldron\tCauldron\t5\t\ts\tval_cauldron\t0\t1,1\ta0 val_cauldron\t0,0,0\rp:Valentine's Lamp\tValentine's Lamp\t10\t\ts\tval_heart\t0\t1,1\t10 val_heart\t0,0,0\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "74", QSql::In);
        query.bindValue(":model", "Rugs", QSql::In);
        query.bindValue(":map", "i:Rugs\rn:Rugs\rl:ctlg_layout2\rs:2: We have rugs for ANY room!\rw:Click on the item you want for more information.\rg:catalog_rugs_headline1\rh:We have rugs for all occasions.  All rugs are non-slip and washable.\re:catalog_rugs_teaser1,\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*4\t0\t3,5\tA1 BM3\t#ccddff\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*5\t0\t3,5\tA1 BM4\t#ddccff\rp:Floor rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard\t0\t3,5\tA1 BM7\t0,0,0\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*b\t0\t3,5\tA1 BMC\t#336666,#336666,#336666\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*a\t0\t3,5\tA1 BMB\t#55AC00,#55AC00,#55AC00\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*3\t0\t3,5\tA1 BM6\t#ffee00\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*2\t0\t3,5\tA1 BM5\t#99DCCC\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*8\t0\t3,5\tA1 BM9\t#999966,#999966,#999966\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*7\t0\t3,5\tA1 BM8\t#99CCFF,#99CCFF,#99CCFF\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*1\t0\t3,5\tA1 BM2\t#ff1f08\rp:Floor Rug\tAvailable in a variety of colours\t3\t\ts\tcarpet_standard*6\t0\t3,5\tA1 BM1\t#777777\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft\t0\t2,4\tA1 MM1\t\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*1\t0\t2,4\tA1 MM2\t#CC3333\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*2\t0\t2,4\tA1 MM3\t#66FFFF\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*3\t0\t2,4\tA1 MM4\t#FFCC99\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*4\t0\t2,4\tA1 MM5\t#FFCCFF\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*5\t0\t2,4\tA1 MM6\t#FFFF66\rp:Soft Wool Rug\tSoft Wool Rug\t3\t\ts\tcarpet_soft*6\t0\t2,4\tA1 MM7\t#669933\rp:Doormat\tWelcome Habbos in style\t1\t\ts\tdoormat_love\t0\t1,1\tA1 OSB\t0,0,0\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*6\t0\t1,1\tA1 BV1\t#777777\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*1\t0\t1,1\tA1 BV2\t#ff1f08\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*4\t0\t1,1\tA1 BV3\t#ccddff\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*5\t0\t1,1\tA1 BV4\t#ddccff\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*2\t0\t1,1\tA1 BV5\t#99DCCC\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain*3\t0\t1,1\tA1 BV6\t#ffee00\rp:Doormat\tAvailable in a variety of colours\t1\t\ts\tdoormat_plain\t0\t1,1\tA1 BV7\t0,0,0\rp:Hand-Woven Rug\tAdds instant warmth\t3\t\ts\tcarpet_armas\t0\t2,4\tA1 RMA\t0,0,0\rp:Faux-Fur Bear Rug\tFor cuddling up on\t4\t\ts\tcarpet_polar\t0\t2,3\tA2 MUR\t#ffffff,#ffffff,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "75", QSql::In);
        query.bindValue(":model", "Smoke Machines", QSql::In);
        query.bindValue(":map", "i:Smoke Machines\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Smoke Machines page. Here you can buy any smoke that will give your room that cloudy feel!\rw:\re:catalog_presents_teaser2,\rp:Aqua Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 aqua_rocket\t#ffffff,#ffffff,#00cccc,#ffffff\rp:Red Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 red_rocket\t#ffffff,#ffffff,#dd2d22,#ffffff\rp:Purple Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 purple_rocket\t#ffffff,#ffffff,#bb55cc,#ffffff\rp:Violet Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 violet_rocket\t#ffffff,#ffffff,#7733ff,#ffffff\rp:Pink Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 pink_rocket\t#ffffff,#ffffff,#ff5577,#ffffff\rp:Jade Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 jade_rocket\t#ffffff,#ffffff,#02bb70,#ffffff\rp:Blue Smoke Machine\tHigh technology in a retro frame\t25\t\ts\tscifirocket*6\t1\t1,1\t3 blue_rocket\t#ffffff,#ffffff,#5599ff,#ffffff\rp:Yellow Smoke Machine\tRetro-mystification\t25\t\ts\tscifirocket*1\t0\t1,1\t3 yellow_rocket\t#ffffff,#ffffff,#ffbc00,#ffffff", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "76", QSql::In);
        query.bindValue(":model", "Spaces", QSql::In);
        query.bindValue(":map", "i:Spaces\rn:Spaces\rl:ctlg_spaces\rt1:Wall\rt2:Floor\rt3:Pattern\rg:catalog_spaces_headline1\rt4:Colour\rt5:Pattern\rt6:Colour\rt7:Preview\rh:Are your walls looking a little grey?  What you need is a splash of paint and this is the place to get it!  <br><br>A splash of colour on the walls and a nice carpet can make all the difference. Use our virtual room below to test out the combinations before you buy. \re:\rp:floor\tFloor\t2\t\ti\tfloor\t\t\t2 l\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 1\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 2\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 3\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 4\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 5\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 6\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 7\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 8\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 9\t\t\t2 t\t\rp:wallpaper\twallpaper\t2\t\ti\twallpaper 10\t\t\t2 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 11\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 12\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 13\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 14\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 15\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 16\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 17\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 18\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 19\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 20\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 21\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 22\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 23\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 24\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 25\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 26\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 27\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 28\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 29\t\t\t5 t\t\rp:wallpaper\twallpaper\t5\t\ti\twallpaper 30\t\t\t5 t\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "77", QSql::In);
        query.bindValue(":model", "Sports", QSql::In);
        query.bindValue(":map", "i:Sports\rn:Sports\rl:ctlg_layout2\rs:2\rh:For the sporty habbos, here is the sports section!\rg:catalog_sports_headline1\rw:\re:catalog_sports_teaser1,\rp:Hockey stick\twhack that ball!\t3\t\ti\tposter 52\t\t\tposter 52\rp:Hockey stick\twhack that ball!\t3\t\ti\tposter 53\t\t\tposter 53\rp:Hockey stick\twhack that ball!\t3\t\ti\tposter 54\t\t\tposter 54\rp:Scoreboard\t...for keeping your score\t6\t\ts\thockey_score\t2\t1,1\t10 hockey_score\t0,0,0\rp:Basketball Trophy\tFor the winning team\t3\t\ts\tlegotrophy\t2\t1,1\t10 legotrophy\t0,0,0\rp:Basketball Hoop\t2 points for every basket\t3\t\ti\tposter 51\t\t\tposter 51\rp:Basketball Court\tLine up your slam dunk\t3\t\ts\tcarpet_legocourt\t2\t3,3\t10 court\t0,0,0\rp:Team Bench\tFor your reserve players\t6\t\ts\tbench_lego\t2\t4,1\t10 teambench\t0,0,0\rp:Sport track straight\tLet's get sporty!\t3\t\ts\tsporttrack1*1\t2\t2,2\t10 track11\t#ffffff,#e4592d,#ffffff\rp:Sport track straight asphalt\tLet's get sporty!\t3\t\ts\tsporttrack1*2\t2\t2,2\t10 track12\t#ffffff,#62818b,#ffffff\rp:Sport track straight grass\tLet's get sporty!\t3\t\ts\tsporttrack1*3\t2\t2,2\t10 track13\t#ffffff,#5cb800,#ffffff\rp:Sport corner\tLet's get sporty!\t3\t\ts\tsporttrack2*1\t2\t2,2\t10 track21\t#ffffff,#e4592d,#ffffff\rp:Sport corner asphalt\tLet's get sporty!\t3\t\ts\tsporttrack2*2\t2\t2,2\t10 track22\t#ffffff,#62818b,#ffffff\rp:Sport corner grass\tLet's get sporty!\t3\t\ts\tsporttrack2*3\t2\t2,2\t10 track23\t#ffffff,#5cb800,#ffffff\rp:Sport goal\tLet's get sporty!\t3\t\ts\tsporttrack3*1\t2\t2,2\t10 track31\t#ffffff,#e4592d,#ffffff\rp:Sport goal asphalt\tLet's get sporty!\t3\t\ts\tsporttrack3*2\t2\t2,2\t10 track32\t#ffffff,#62818b,#ffffff\rp:Sport goal grass\tLet's get sporty!\t3\t\ts\tsporttrack3*3\t2\t2,2\t10 track33\t#ffffff,#5cb800,#ffffff\r", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "78", QSql::In);
        query.bindValue(":model", "Super Rare", QSql::In);
        query.bindValue(":map", "i:Rare\rn:Rars\rl:ctlg_productpage1\rs:\rh:The Super Rare of the Day! Limited Time Only! get it while it's HAWT!:\rg:catalog_rares_headline1\rt1:Rare txt\rw:\re:\rp:Jade Monolith\tMonolith goes up! Monolith goes down!\t25\t\ts\tscifidoor*6\t0\t1,1\ta9 mono_jade\t#ffffff,#99dd77,#99dd77,#99dd77,#ffffff\r\n", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "79", QSql::In);
        query.bindValue(":model", "Teleports", QSql::In);
        query.bindValue(":map", "i:Teleports\rn:Teleports\rl:ctlg_productpage3\rs:Teleport!\rw:Select an item by clicking one of the icons on the left.\rg:catalog_doors_headline1\rh:Beam your Habbo from one room to another with one of our cunningly disguised, space age teleports. Now you can link any two rooms together! Teleports are sold in pairs, so if you trade for them, check you're getting a linked pair.\re:catalog_door_a,catalog_door_c,catalog_door_b,\rp:Telephone Box\tDr Who?\t5\t\ts\tdoor\t0\t1,1\ta2 ovi\t\rp:Portaloo\tIn a hurry?\t4\t\ts\tdoorC\t0\t1,1\ta2 ovi3\t\rp:Wardrobe\tNarnia this way!\t3\t\ts\tdoorB\t0\t1,1\ta2 ovi2\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "80", QSql::In);
        query.bindValue(":model", "Trax", QSql::In);
        query.bindValue(":map", "i:Trax\rn:Trax\rl:ctlg_soundmachine\rh:With the Traxmachine you can play musin on Habbo! Just buy a machine and a song from this page and listen!\rg:catalog_djshop_headline1\re:catalog_djshop_teaser1,\rp:Traxmachine Pack\tTraxmachine With DJ Fuse's Duck Funk\t10\t\td\t\t\t\tdeal0110\t\t2\tsound_machine*1\t1\t#FFFFFF,#FFFFFF,#828282,#FFFFFF\tsound_set_1\t1\t\rp:DJ Fuse's Duck Funk\tMusic\t5\t\ts\tsound_set_1\t0\t1,1\tA0 sound_set1\t\rp:DJ Fuse's Habbo Theme\tMusic\t5\t\ts\tsound_set_2\t0\t1,1\tA0 sound_set2\t\rp:Snow Storm Theme\tMusic\t5\t\ts\tsound_set_3\t0\t1,1\tA0 sound_set3\t\rp:Sunset Adventure\tMusic\t5\t\ts\tsound_set_4\t0\t1,1\tA0 sound_set4\t\rp:Dark Skies\tMusic\t5\t\ts\tsound_set_5\t0\t1,1\tA0 sound_set5\t\rp:Ambiences\tMusic\t5\t\ts\tsound_set_6\t0\t1,1\tA0 sound_set6\t\rp:Furni Sounds\tMusic\t5\t\ts\tsound_set_7\t0\t1,1\tA0 sound_set7\t\rp:Electronica\tMusic soundeja\t5\t\ts\tsound_set_8\t0\t1,1\tA0 sound_set8\t\rp:Mysto Magica\tMusic\t5\t\ts\tsound_set_9\t0\t1,1\tA0 sound_set9\t", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "81", QSql::In);
        query.bindValue(":model", "Trophies", QSql::In);
        query.bindValue(":map", "i:Trophies\rn:Trophies\rl:ctlg_trophies\rh:Reward your Habbo friends, or yourself with one of our fabulous glittering array of bronze, silver and gold trophies.<br><br>First choose the trophy model (click on the arrows to see all the different styles) and then the metal (click on the seal below the trophy). Type your inscription below and we'll engrave it on the trophy along with your name and today's date.<br>\rg:catalog_trophies_headline1\rt1:Type your inscription CAREFULLY, it's permanent!\re:\rp:Duck trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy2*3\t0\t1,1\ta0 prizetrophy2_b\t#ffffff,#ffffff,#996600\rp:Duo trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy5*3\t0\t1,1\ta0 prizetrophy5_b\t#ffffff,#ffffff,#996600\rp:Classic trophy\tGlittery gold\t12\t\ts\tprizetrophy*1\t0\t1,1\ta0 prizetrophy_g\t#ffffff,#ffffff,#FFDD3F\rp:Duck trophy\tGlittery gold\t12\t\ts\tprizetrophy2*1\t0\t1,1\ta0 prizetrophy2_g\t#ffffff,#ffffff,#FFDD3F\rp:Duo trophy\tGlittery gold\t12\t\ts\tprizetrophy5*1\t0\t1,1\ta0 prizetrophy5_g\t#ffffff,#ffffff,#FFDD3F\rp:Classic trophy\tShiny silver\t10\t\ts\tprizetrophy*2\t0\t1,1\ta0 prizetrophy_s\t#ffffff,#ffffff,#ffffff\rp:Duck trophy\tShiny silver\t10\t\ts\tprizetrophy2*2\t0\t1,1\ta0 prizetrophy2_s\t#ffffff,#ffffff,#ffffff\rp:Duo trophy\tShiny silver\t10\t\ts\tprizetrophy5*2\t0\t1,1\ta0 prizetrophy5_s\t#ffffff,#ffffff,#ffffff\rp:Classic trophy\tBreathtaking bronze\t8\t\ts\tprizetrophy*3\t0\t1,1\ta0 prizetrophy_b\t#ffffff,#ffffff,#996600", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "82", QSql::In);
        query.bindValue(":model", "White Mode", QSql::In);
        query.bindValue(":map", "i:White Mode\rn:White Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed\t0,0,#DFDFDF,#DFDFDF,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed\t0,0,0,#DFDFDF,#DFDFDF,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa\t0,0,0,0,#DFDFDF,#DFDFDF\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair\t0,0,#DFDFDF,#DFDFDF,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate\t0,0,0,#DFDFDF,#DFDFDF\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar\t0,0,#DFDFDF,#DFDFDF\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar\t0,#DFDFDF,0", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "83", QSql::In);
        query.bindValue(":model", "Yellow Iced", QSql::In);
        query.bindValue(":map", "i:Yellow Iced\rn:Yellow Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. It's so chic, it says everything and nothing. It's a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair\tSleek and chic for each cheek\t3\t\ts\tchair_norja\t0\t1,1\tA1 TUN_yellow\t0,#EFC933,#EFC933,#EFC933\rp:Bench\tTwo can perch comfortably\t3\t\ts\tcouch_norja\t0\t2,1\tA1 PEN_yellow\t0,0,0,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933\rp:Coffee Table\tElegance embodied\t3\t\ts\ttable_norja_med\t0\t2,2\tA1 PYN_yellow\t0,#EFC933\rp:Bookcase\tFor nic naks and art deco books\t3\t\ts\tshelves_norja\t0\t1,1\tA1 HYN_yellow\t#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933\rp:iced sofachair\tSoft iced sofachair\t3\t\ts\tsoft_sofachair_norja\t0\t1,1\ta2 stn_yellow\t0,#EFC933,#EFC933\rp:iced sofa\tA soft iced sofa\t4\t\ts\tsoft_sofa_norja\t0\t2,1\tA2 PSN_yellow\t#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933\rp:Ice Bar-Desk\tStrong, yet soft looking\t3\t\ts\tdivider_nor2\t0\t2,1\ta1 nordiv_yellow\t0,0,#EFC933,#EFC933,#EFC933,#EFC933\rp:Ice Corner\tLooks squishy, but isn't\t3\t\ts\tdivider_nor1\t0\t1,1\ta1 norkp_yellow\t0,#EFC933,0,0,0,0\rp:Iced Auto Shutter\tHabbos, roll out!\t3\t\ts\tdivider_nor4\t0\t2,1\ta1 divider_nor4_yellow\t0,0,#EFC933,#EFC933,#EFC933,#EFC933\rp:Iced Angle\tCool cornering for your crib y0!\t3\t\ts\tdivider_nor5\t0\t1,1\ta1 divider_nor5_yellow\t0,#EFC933,#EFC933,#EFC933,#EFC933\rp:Door (Lockable)\tDo go through...\t6\t\ts\tdivider_nor3\t0\t1,1\ta2 norovi_yellow\t0,0,#EFC933,#EFC933", QSql::In);
        query.exec();

        query.prepare("INSERT INTO catalog (id, pagename, pagepacket) VALUES(:id, :model, :map)");
        query.bindValue(":id", "84", QSql::In);
        query.bindValue(":model", "Yellow Mode", QSql::In);
        query.bindValue(":map", "i:Yellow Mode\rn:Yellow Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed\tGive yourself space to stretch out\t4\t\ts\tbed_polyfon\t0\t2,3\t4 mdbed\t0,0,#DAB831,#DAB831,0,0\rp:Single Bed\tCot of the artistic\t3\t\ts\tbed_polyfon_one\t0\t1,3\t3 msbed\t0,0,0,#DAB831,#DAB831,0\rp:Fireplace\tComfort in stainless steel\t5\t\ts\tfireplace_polyfon\t2\t2,1\t5 mfire\t0,0,0\rp:Two-seater Sofa\tComfort for stylish couples\t4\t\ts\tsofa_polyfon\t0\t2,1\t4 msofa\t0,0,0,0,#DAB831,#DAB831\rp:Armchair\tLoft-style comfort\t3\t\ts\tsofachair_polyfon\t0\t1,1\t3 mschair\t0,0,#DAB831,#DAB831,0\rp:Mini-Bar\tYou naughty Habbo!\t5\t\ts\tbar_polyfon\t2\t1,1\t5 mmbar\t\rp:Hatch (Lockable)\tAll bars should have one\t6\t\ts\tdivider_poly3\t0\t1,1\t6 mgate\t0,0,0,#DAB831,#DAB831\rp:Bar/desk\tPerfect for work or play\t3\t\ts\tbardesk_polyfon\t0\t2,1\t3 mbar\t0,0,#DAB831,#DAB831\rp:Corner Cabinet/Desk\tTuck it away\t3\t\ts\tbardeskcorner_polyfon\t0\t1,1\t3 mcbar\t0,#DAB831,0", QSql::In);
        query.exec();

        //query.prepare("INSERT INTO furniture id INTEGER PRIMARY KEY, inroom INTEGER, inhand INTEGER, sprite VARCHAR(64), x INTEGER, y INTEGER, length INTEGER, width INTEGER, rot INTEGER, z INTEGER, color VARCHAR(250), status VARCHAR(250), teleid INTEGER)");//(

        /* end generated automatically */
    }
    printf("                        [OK]\n\n");
    FurnitureProfile::init();// it should still work shouldnt it?
}
